#ifndef _ROOTKITDEFS_H_
#define _ROOTKITDEFS_H_

// TODO: Make code use ReactOS NDK instead of this BS.

#pragma pack(1)

typedef struct ServiceDescriptorEntry {
	unsigned int *ServiceTableBase;
	unsigned int *ServiceCounterTableBase; //Used only in checked build
	unsigned int NumberOfServices;
	unsigned char *ParamTableBase;
} ServiceDescriptorTableEntry_t, *PServiceDescriptorTableEntry_t;

#pragma pack()

// Found these two on some random forum
typedef struct 
{
    ULONG           AllocationSize;
    ULONG           Size;
    ULONG           Flags;
    ULONG           Reserved;
    LONG            Console;
    ULONG           ProcessGroup;
    HANDLE          hStdInput;
    HANDLE          hStdOutput;
    HANDLE          hStdError;
    UNICODE_STRING  CurrentDir;
    HANDLE          CurrentDirectoryHandle;
    UNICODE_STRING  LoadSearchPath;
    UNICODE_STRING  ImageName;
    UNICODE_STRING  CommandLine;
    PWSTR           Enviroment;
    ULONG           dwX;
    ULONG           dwY;
    ULONG           dwXSize;
    ULONG           dwYSize;
    ULONG           dwXCountChars;
    ULONG           dwYCountChars;
    ULONG           dwFillAttributes;
    ULONG           dwFlags;
    ULONG           wShowWindow;
    UNICODE_STRING  WindowTitle;
    UNICODE_STRING  Desktop;
    UNICODE_STRING  Reserved1;
    UNICODE_STRING  Reserved2;
} PROCESS_PARAMETERS, *PPROCESS_PARAMETERS;

// ReactOS
typedef struct _PEB_LDR_DATA
{   
	ULONG               Length;                      
	BOOLEAN             Initialized;                 
	PVOID               SsHandle;                    
	LIST_ENTRY          InLoadOrderModuleList;       
	LIST_ENTRY          InMemoryOrderModuleList;
	LIST_ENTRY          InInitializationOrderModuleList;
} PEB_LDR_DATA, *PPEB_LDR_DATA;       

//
// Loader Data Table Entry - ReactOS
//
typedef struct _LDR_DATA_TABLE_ENTRY
{   
    LIST_ENTRY InLoadOrderModuleList;
    LIST_ENTRY InMemoryOrderModuleList; 
    LIST_ENTRY InInitializationOrderModuleList;
    PVOID DllBase;
    PVOID EntryPoint;
    ULONG SizeOfImage;
    UNICODE_STRING FullDllName;
    UNICODE_STRING BaseDllName;
    ULONG Flags;
    USHORT LoadCount;
    USHORT TlsIndex;
    union
    {
        LIST_ENTRY HashLinks;
        PVOID SectionPointer;
    };
    ULONG CheckSum;
    union
    { 
        ULONG TimeDateStamp;
        PVOID LoadedImports;
    };
    PVOID EntryPointActivationContext;               
    PVOID PatchInformation;
} LDR_DATA_TABLE_ENTRY, *PLDR_DATA_TABLE_ENTRY;      
        
 

typedef struct 
{
    BOOLEAN              InheritedAddressSpace;
    BOOLEAN              ReadImageFileExecOptions;
    BOOLEAN              BeingDebugged;
    BYTE                 b003;
    DWORD                d004;
    PVOID                SectionBaseAddress;
    PPEB_LDR_DATA 		 Ldr;
    PPROCESS_PARAMETERS  ProcessParameters;
    DWORD                SubSystemData;
    HANDLE               ProcessHeap;
    PVOID/*PCRITICAL_SECTION*/    FastPebLock;
    PVOID                AcquireFastPebLock; 
    PVOID                ReleaseFastPebLock; 
    DWORD                d028;
    PVOID*               User32Dispatch;     
    DWORD                d030;
    DWORD                d034;
    DWORD                d038;
    DWORD                TlsBitMapSize;      
    PRTL_BITMAP          TlsBitMap;          
    DWORD                TlsBitMapData [2]; 
    PVOID                p04C;
    PVOID                p050;
    PVOID/*PTEXT_INFO*/           TextInfo;
    PVOID                InitAnsiCodePageData;
    PVOID                InitOemCodePageData;
    PVOID                InitUnicodeCaseTableData;
    DWORD                KeNumberProcessors;
    DWORD                NtGlobalFlag;
    DWORD                d6C;
    LARGE_INTEGER        MmCriticalSectionTimeout;
    DWORD                MmHeapSegmentReserve;
    DWORD                MmHeapSegmentCommit;
    DWORD                MmHeapDeCommitTotalFreeThreshold;
    DWORD                MmHeapDeCommitFreeBlockThreshold;
    DWORD                NumberOfHeaps;
    DWORD                AvailableHeaps; 
    PHANDLE              ProcessHeapsListBuffer;
    DWORD                d094;
    DWORD                d098;
    DWORD                d09C;
    PVOID/*PCRITICAL_SECTION*/    LoaderLock;
    DWORD                NtMajorVersion;
    DWORD                NtMinorVersion;
    WORD                 NtBuildNumber;
    WORD                 CmNtCSDVersion;
    DWORD                PlatformId;
    DWORD                Subsystem;
    DWORD                MajorSubsystemVersion;
    DWORD                MinorSubsystemVersion;
    KAFFINITY            AffinityMask;
    DWORD                ad0C4 [35];
    PVOID                p150;
    DWORD                ad154 [32];
    HANDLE               Win32WindowStation;
    DWORD                d1D8;
    DWORD                d1DC;
    PWORD                CSDVersion;
    DWORD                d1E4;
 } MPEB,*PMPEB;

// Reactos.. Crossing fingers..
typedef struct _W32THREAD
{
	PVOID MessageQueue;
	LIST_ENTRY WindowListHead;
	LIST_ENTRY W32CallbackListHead;
	PVOID KeyboardLayout;
	PVOID Desktop;
	HANDLE hDesktop;
	DWORD MessagePumpHookValue;
	BOOLEAN IsExiting;
} W32THREAD, *PW32THREAD;



// ReactOS's offsets for these are actually totally busticated
// Offsets courtesy of windbag
// XXX: These are all specific to XP SP2...
// Need to make macros and do version detection like FU, but I don't
// have access to other types of boxen
typedef struct _KTHREAD
{
	UCHAR junk[0xE0];
	PVOID ServiceTable; /* 0xe0 */
	UCHAR junk2[76];    /* 0xe4 */
	PW32THREAD Win32Thread;  /* 0x130 */
	UCHAR junk3[116];	/* 0x134 */
	LIST_ENTRY ThreadListEntry; /* 0x1B0 */
} MKTHREAD;

#define DKOM_MAGIC_INIT		(0x1337bab0)

#define DKOM_THREAD_HIDDEN	(1<<0)
#define DKOM_DLL_HIDDEN		(1<<1)
#define DKOM_WINDOW_HIDDEN	(1<<2)
#define DKOM_PPID_SET		(1<<3)

typedef struct _EPROCESS
{
	UCHAR junk[0x84];
	ULONG PID;
	LIST_ENTRY ActiveProcessLinks; /* 0x88 */
	UCHAR junk2[188];
	ULONG PPID;		/* 0x14C */
	UCHAR junk3[0x24]; /* 0x150 */
	union {
		// Wow.exe will always be small enough for this
		CHAR ImageFileName[0x10]; /* 0x174 */
		DWORD DidDKOM[4];
	};
	UCHAR junk4[0xC]; /* 0x184 */
	LIST_ENTRY ThreadListHead; /* 0x190 */
	UCHAR junk5[24]; /* 198 */
	MPEB *peb; /* 1B0 */
} MEPROCESS;

typedef struct _KPROCESS
{
	UCHAR junk[0x50];
	LIST_ENTRY ThreadListHead; /* 0x50 */
	UCHAR junk2[0x18]; /* 0x58 */
} MKPROCESS;

typedef struct _ETHREAD
{
	UCHAR junk[0x224];
	ULONG StartAddress; /* 224 */
	UCHAR junk2[4];    /* 228 */
	LIST_ENTRY ThreadListEntry; /* 22C */
} METHREAD;



__declspec(dllimport)  ServiceDescriptorTableEntry_t KeServiceDescriptorTable[4];
extern ServiceDescriptorTableEntry_t *KeServiceDescriptorTableShadow;

#define SYSTEM_SERVICE(_function) KeServiceDescriptorTable[0].ServiceTableBase[*(PULONG)((PUCHAR)_function+1)]
#define SYSTEM_SERVICE_IDX(_index) KeServiceDescriptorTable[0].ServiceTableBase[_index]

#define SDW_SYSTEM_SERVICE(_function) KeServiceDescriptorTableShadow[0].ServiceTableBase[*(PULONG)((PUCHAR)_function+1)]
#define SDW_SYSTEM_SERVICE_IDX(_index) KeServiceDescriptorTableShadow[0].ServiceTableBase[_index]

#define WIN32K_SERVICE(_function) KeServiceDescriptorTableShadow[1].ServiceTableBase[*(PULONG)((PUCHAR)_function+1)]
#define WIN32K_SERVICE_IDX(_index) KeServiceDescriptorTableShadow[1].ServiceTableBase[_index]


#define OFFSET_OF(type, field) ((ULONG)(&(((type *)NULL)->field)))

// Stolen from mingw's ntapi.h
typedef enum _MEMORY_INFORMATION_CLASS {
	MemoryBasicInformation,
	MemoryWorkingSetList,
	MemorySectionName,
	MemoryBasicVlmInformation
} MEMORY_INFORMATION_CLASS;

// stolen from MSDN dox
typedef struct _MEMORY_BASIC_INFORMATION {  
	PVOID BaseAddress;  
	PVOID AllocationBase;  
	DWORD AllocationProtect;  
	SIZE_T RegionSize;  
	DWORD State;  
	DWORD Protect;  
	DWORD Type;
} MEMORY_BASIC_INFORMATION, *PMEMORY_BASIC_INFORMATION;

typedef struct _THREAD_BASIC_INFORMATION
{
	NTSTATUS ExitStatus;
	PVOID TebBaseAddress;
	CLIENT_ID ClientId;
	KAFFINITY AffinityMask;
	KPRIORITY Priority;
	KPRIORITY BasePriority;
} THREAD_BASIC_INFORMATION, *PTHREAD_BASIC_INFORMATION;


// Stolen from free ntifs.h
typedef struct _KAPC_STATE {
    LIST_ENTRY  ApcListHead[2];
    PEPROCESS   Proc;
    BOOLEAN     KernelApcInProgress;
    BOOLEAN     KernelApcPending;
    BOOLEAN     UserApcPending;
	char extrajustincase[128]; // s3kur3 c0d3rz gu1ld m3mb3r #2369
} KAPC_STATE, *PKAPC_STATE;

// ReactOS
typedef enum _SYSTEM_INFORMATION_CLASS {
    SystemBasicInformation,
    SystemProcessorInformation,
    SystemPerformanceInformation,
    SystemTimeOfDayInformation,
    SystemPathInformation, /// Obsolete: Use KUSER_SHARED_DATA
    SystemProcessInformation,
    SystemCallCountInformation,
    SystemDeviceInformation,
    SystemProcessorPerformanceInformation,
    SystemFlagsInformation,
    SystemCallTimeInformation,
    SystemModuleInformation,
    SystemLocksInformation,
    SystemStackTraceInformation,
    SystemPagedPoolInformation,
    SystemNonPagedPoolInformation,
    SystemHandleInformation,
    SystemObjectInformation,
    SystemPageFileInformation,
    SystemVdmInstemulInformation,
    SystemVdmBopInformation,
    SystemFileCacheInformation,
    SystemPoolTagInformation,
    SystemInterruptInformation,
    SystemDpcBehaviorInformation,
    SystemFullMemoryInformation,
    SystemLoadGdiDriverInformation,
    SystemUnloadGdiDriverInformation,
    SystemTimeAdjustmentInformation,
    SystemSummaryMemoryInformation,
    SystemNextEventIdInformation,
    SystemEventIdsInformation,
    SystemCrashDumpInformation,
    SystemExceptionInformation,
    SystemCrashDumpStateInformation,
    SystemKernelDebuggerInformation,
    SystemContextSwitchInformation,
    SystemRegistryQuotaInformation,
    SystemExtendServiceTableInformation,
    SystemPrioritySeperation,
    SystemPlugPlayBusInformation,
    SystemDockInformation,
    SystemPowerInformationNative,
    SystemProcessorSpeedInformation,
    SystemCurrentTimeZoneInformation,
    SystemLookasideInformation,
    SystemTimeSlipNotification,
    SystemSessionCreate,
    SystemSessionDetach,
    SystemSessionInformation,
    SystemRangeStartInformation,
    SystemVerifierInformation,
    SystemAddVerifier,
    SystemSessionProcessesInformation,
    SystemInformationClassMax
} SYSTEM_INFORMATION_CLASS;

#define TEB_UNICODE_STORAGE_OFFSET (0xC00) // XP SP2 + ReactOS

// Class 11
typedef struct _SYSTEM_MODULE_INFORMATION_ENTRY
{
    ULONG  Unknown1;
    ULONG  Unknown2;
    PVOID  Base;
    ULONG  Size;
    ULONG  Flags;
    USHORT  Index;
    USHORT  NameLength;
    USHORT  LoadCount;
    USHORT  PathLength;
    CHAR  ImageName[256];
} SYSTEM_MODULE_INFORMATION_ENTRY, *PSYSTEM_MODULE_INFORMATION_ENTRY;
typedef struct _SYSTEM_MODULE_INFORMATION
{
    ULONG Count;
    SYSTEM_MODULE_INFORMATION_ENTRY Module[1];
} SYSTEM_MODULE_INFORMATION, *PSYSTEM_MODULE_INFORMATION;


NTSYSAPI
VOID
KeStackAttachProcess (
    PEPROCESS    Process,
    PKAPC_STATE ApcState
);

NTSYSAPI
VOID
KeUnstackDetachProcess (
    PKAPC_STATE ApcState
);

NTSYSAPI
NTSTATUS
NTAPI
ZwOpenProcess (
    OUT PHANDLE             ProcessHandle,
    IN ACCESS_MASK          DesiredAccess,
    IN POBJECT_ATTRIBUTES   ObjectAttributes,
    IN PCLIENT_ID           ClientId OPTIONAL
);




#define MEM_EXECUTE_OPTION_DISABLE      0x1
#define MEM_EXECUTE_OPTION_ENABLE       0x2
#define MEM_EXECUTE_OPTION_PERMANENT    0x8


NTSYSAPI BOOLEAN KeAddSystemServiceTable( IN PULONG_PTR Base, IN PULONG Count OPTIONAL, IN ULONG Limit, IN PUCHAR Number, IN ULONG Index); 
//NTSTATUS NTAPI RtlEnterCriticalSection(PRTL_CRITICAL_SECTION CriticalSection);
NTSTATUS NTAPI RtlEnterCriticalSection(PVOID CriticalSection);
NTSTATUS NTAPI RtlLeaveCriticalSection(PVOID CriticalSection);
NTSTATUS NTAPI PsLookupProcessByProcessId(ULONG, MEPROCESS **);

// found these from either ntapi.h or ntifs.h 
NTSYSAPI NTSTATUS NTAPI ZwQueryInformationProcess(HANDLE ProcessHandle,PROCESSINFOCLASS ProcessInformationClass,PVOID ProcessInformation,ULONG ProcessInformationLength,PULONG ReturnLength);
NTSYSAPI NTSTATUS NTAPI ZwQueryInformationThread(HANDLE ThreadHandle,THREADINFOCLASS ThreadInformationClass,PVOID ThreadInformation,ULONG ProcessInformationLength,PULONG ReturnLength);
NTSYSAPI NTSTATUS NTAPI ZwSetInformationProcess ( IN HANDLE           ProcessHandle, IN PROCESSINFOCLASS ProcessInformationClass, IN PVOID            ProcessInformation, IN ULONG            ProcessInformationLength);
NTSYSAPI NTSTATUS NTAPI ZwAllocateVirtualMemory(HANDLE ProcessHandle,PVOID *BaseAddress,ULONG ZeroBits,PULONG AllocationSize,ULONG AllocationType,ULONG Protect);
NTSYSAPI NTSTATUS NTAPI ZwFreeVirtualMemory(HANDLE ProcessHandle,PVOID *BaseAddress,PULONG FreeSize,ULONG FreeType);
NTSYSAPI NTSTATUS NTAPI ZwProtectVirtualMemory(HANDLE ProcessHandle,PVOID *BaseAddr,PULONG size, ULONG newprot, PULONG oldprot);
NTSYSAPI NTSTATUS NTAPI ZwFlushInstructionCache ( IN HANDLE   ProcessHandle, IN PVOID    BaseAddress OPTIONAL, IN ULONG    FlushSize);
NTSYSAPI NTSTATUS NTAPI ZwQueryVirtualMemory( IN HANDLE  ProcessHandle, IN PVOID  BaseAddress, IN MEMORY_INFORMATION_CLASS  MemoryInformationClass, OUT PVOID  MemoryInformation, IN ULONG  MemoryInformationLength, OUT PULONG  ReturnLength  OPTIONAL);
NTSYSAPI NTSTATUS NTAPI ZwTerminateProcess ( IN HANDLE ProcessHandle OPTIONAL, IN NTSTATUS ExitStatus ); 
NTSYSAPI NTSTATUS NTAPI ZwFreeVirtualMemory(HANDLE proc, PVOID* addr, PULONG size, DWORD dwfreetype);
NTSYSAPI NTSTATUS NTAPI ZwMapViewOfSection( IN HANDLE  SectionHandle, IN HANDLE  ProcessHandle, IN OUT PVOID  *BaseAddress, IN ULONG  ZeroBits, IN ULONG  CommitSize, IN OUT PLARGE_INTEGER  SectionOffset  OPTIONAL, IN OUT PSIZE_T  ViewSize, IN SECTION_INHERIT  InheritDisposition, IN ULONG  AllocationType, IN ULONG  Protect);
NTSYSAPI NTSTATUS NTAPI ZwQueryVirtualMemory (IN HANDLE ProcessHandle, IN PVOID Address, IN MEMORY_INFORMATION_CLASS VirtualMemoryInformationClass, OUT PVOID VirtualMemoryInformation, IN ULONG Length, OUT PULONG UnsafeResultLength);

NTSYSAPI INT      NTAPI NtUserInternalGetWindowText(HWND hWnd, LPWSTR lpString, INT nMaxCount);
NTSYSAPI NTSTATUS NTAPI ZwMapViewOfSection( IN HANDLE  SectionHandle, IN HANDLE  ProcessHandle, IN OUT PVOID  *BaseAddress, IN ULONG  ZeroBits, IN ULONG  CommitSize, IN OUT PLARGE_INTEGER  SectionOffset  OPTIONAL, IN OUT PSIZE_T  ViewSize, IN SECTION_INHERIT  InheritDisposition, IN ULONG  AllocationType, IN ULONG  Protect);
NTSYSAPI NTSTATUS NTAPI ZwReadVirtualMemory(IN HANDLE ProcessHandle, IN PVOID BaseAddress, OUT PVOID Buffer, IN ULONG NumberOfBytesToRead, OUT PULONG NumberOfBytesRead OPTIONAL);
NTSYSAPI NTSTATUS NTAPI NtQuerySystemInformation (IN SYSTEM_INFORMATION_CLASS SystemInformationClass, OUT PVOID SystemInformation, IN ULONG Length, OUT PULONG UnsafeResultLength); 


NTSYSAPI NTSTATUS ZwOpenSection(
		OUT PHANDLE  SectionHandle,
		IN ACCESS_MASK  DesiredAccess,
		IN POBJECT_ATTRIBUTES  ObjectAttributes
		);

#define IOCTL_TRANSFER_TYPE( _iocontrol)   (_iocontrol & 0x3)
#define SEC_IMAGE	(0x1000000)

#endif
