#ifndef _TRON_KERNEL_H_
#define _TRON_KERNEL_H_


typedef struct _PermsEntry
{
    DWORD cr3;
    DWORD AllowedCodeStart;
    DWORD AllowedCodeEnd;
    DWORD VirtStart;
    DWORD VirtEnd;
#ifdef _PERF_DEBUG_
    DWORD hits;
#endif
} PermsEntry;

typedef struct _HookedPage
{
    DWORD cr3;
    DWORD CloakedVirtualAddress;
    DWORD HookedPageCallback;
    DWORD FakeAddr; // Physical Addr
#ifdef _PERF_DEBUG_
    DWORD hits;
#endif
#ifdef _IRQ_DEBUG_
    KIRQL maxIrql;
    KIRQL minIrql;
#endif
} HookedPage;

typedef struct _FakeAlloc // Tracks allocated memory only
{
    DWORD pid;
    DWORD CloakedVirtualAddr;
    DWORD FakeVirtualAddr;
    DWORD FakeSize;
} FakeAlloc;

#define MAX_PIDS        (23)
#define MAX_FAKES      ((PAGE_SIZE/sizeof(FakeAlloc))-1)
#define MAX_PERMS       ((PAGE_SIZE/sizeof(PermsEntry))-1)
// This should be enough to describe 10.2MB of 4k pages
#define MAX_HOOKS       ((20*PAGE_SIZE/sizeof(HookedPage))-1)

#define PROCESS_PAGE_DIR_BASE      0xC0300000
#define PROCESS_PAGE_TABLE_BASE    0xC0000000

#endif
